 
c Copyright (c) 1990 by James A. D. Connolly, Institute for Mineralogy and
c Petrography, Swiss Federal Insitute of Technology, CH-8092 Zurich,
c SWITZERLAND. All rights reserved.
 
c MU_2_F - a program to convert plots as a function of chemical potential
c to activity or fugacity
 
c Please do not distribute any part of this source.
 
 
      PROGRAM MU_2_F
 
      implicit double precision (a-g,o-z),integer (h-n)
 
      character*100 n4name, n5name
 
      common / basic /n4,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)
 
      n4 = 24
      nps = 25

      write (*,1020) 
      read (*,'(a)') n4name
 
      open (n4,err=90,file=n4name,status='old')
      read (n4,*,err=91) icopt

      n5name = n4name 
      call inblnk (n5name,'m')
      open (nps,file=n5name,status='unknown')

      write (nps,*) icopt

      open (99,file='temp',status='unknown')

      if (icopt.eq.1.or.icopt.ge.5) then 

         call mxypl (n4name)
         goto 98 

      else 
 
         goto 91
 
      end if
 
      goto 999
90    write (*,1040) n4name
      goto 999
91    write (*,1050) n4name
      goto 999
 
98    close (99)
      close (n4)
      close (nps)
 
1010  format (a1)
1020  format (/,'Enter the Perple_X plot file name: ')
1040  format (/,'No such file as:',/,a,/)
1050  format (/,'File:',/,a,/,'is not formatted correctly.',/)
1060  format (80a1)
1070  format (/,'The new plot file will be named:',/,a,/)

999   end


c---------------------------------------------------------------------
      subroutine mxypl (n4name)
 
c psxypl - subroutine to output x-y plot.

      implicit double precision (a-g,o-z),integer (h-n)
 
      character*162 fname(4), n4name*100, bigrec, chars(5)*1
      character*5 cname, yes*1, vname*8, names*8, sname*10, tname
 
      include 'perplex_parameters.h'

      double precision atwt(k5), dblk(3,k5)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
 
      common/ cst8  /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
     *      / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
      common/ basic /n4,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)
     *      / csta4 /cname(k5)/ cst12 /cp(k5,k1)/ cst315 /jcont
     *      / cst5  /p,t,xco2,u1,u2,tr,pr,r,ps/ csta10 /tname(2)
     *      / cst319 /iemod(k2),kmod 


      read (n4,*) iphct, isoct, jcomp, jbulk, ivol, icp, jvol, kmod
      write (nps,1060) iphct, isoct, jcomp
      write (nps,1060) jbulk, ivol, icp, jvol, kmod

      if (jcomp.ne.0) then
         read (n4,1040) (cname(i), i = 1, jcomp)
         read (n4,*) (atwt(i), i = 1, jcomp)
         write (nps,1040) (cname(i), i = 1, jcomp)
         write (nps,1050) (atwt(i), i = 1, jcomp)
      end if 

      if (iphct.ne.0) then
         read (n4,1010) (names(i),i = 1, iphct)
         read (n4,*) ((cp(j,i), j= 1, jcomp), i = 1, iphct)
         read (n4,*) (ikp(i), i = 1, iphct)
         write (nps,1010) (names(i),i = 1, iphct)
         write (nps,1050) ((cp(j,i), j= 1, jcomp), i = 1, iphct)
         write (nps,1060) (ikp(i), i = 1, iphct)
      end if

      if (isoct.ne.0) read (n4,1030) (sname(i), i = 1, isoct)
      if (isoct.ne.0) write (nps,1030) (sname(i), i = 1, isoct)
 
      read (n4,1000) fname
      read (n4,*) iv,(jv(i),i=1,iv),jpt
      read (n4,*) jcont,iind,idep,c0,c1,c2,c3,c4
      read (n4,*) (vmax(i),vmin(i),i=1,iv)
      write (nps,1000) fname
      write (nps,1060) iv,(jv(i),i=1,iv),jpt
      write (nps,1120) jcont,iind,idep,c0,c1,c2,c3,c4
      read (n4,1000) (vname(i),i=1,iv)

      jvct = 0 
      xco2 = 0d0

      do i = 1, iv
         if (jv(i).gt.3.and.i.lt.3) then
            write (*,1100) vname(i)
            read (*,'(a1)') yes
            if (yes.eq.'y'.or.yes.eq.'Y') then
               jvct = jvct + 1
               jcv(jvct) = i
               read (vname(i),'(2x,5a1)') chars
               do j = 1, 5
                  if (chars(j).eq.')') chars(j) = ' '
               end do 
               write (tname(i),'(5a1)') chars
               vname(i) = 'lf_'//tname(i)
               write (*,1110) vname(i)
            end if 
         else if (jv(i).eq.2) then
            jtv = i
            t0 = vmin(i)
            if (iind.ne.0) p0 = depvar(t0)
         else if (jv(i).eq.1) then
            jpv = i
            p0 = vmin(i)
            if (iind.ne.0) t0 = depvar(p0)
         end if 
      end do 

      if (jvct.eq.0) then
         write (*,*) ' No variables to convert, siyanara!'
         goto 99 
      end if 
c                                 ok, if we're here we need
c                                 thermo data
      call mudata
c                                 reset p t
      p = p0
      t = t0 
c                                 convert limits first
      call mcnver (vmax(1),vmax(2))
      call mcnver (vmin(1),vmin(2))

      if (icopt.gt.4) call mplinp (n4name,jcomp)

      if (icopt.ne.5) call mcurv (iend)

      if (iend.eq.0.and.icopt.ne.5) call mipts

      write (nps,1050) (vmax(i),vmin(i),i=1,iv)
      write (nps,1000) (vname(i),i=1,iv)

c                                  gridded minimization files:
      if (icopt.eq.5) then 
c                                       compositions
         if (jcont.gt.0) then 
            read (n4,*) ((dblk(i,j),j=1,jbulk),i=1,jcont+1)
            read (nps,*) ((dblk(i,j),j=1,jbulk),i=1,jcont+1)
         end if 
c                                       grid plot file
         read (n4,*) loopx, loopy
         write (nps,*) loopx, loopy
c                                       grid data
         do i = 1, loopx
            jst = 1
            do while (jst.le.loopy)
               read (n4,*) irep, kd
               write (nps,*) irep, kd
               jst = jst + irep + 1
            end do 
         end do 
      else             

         if (jbulk.eq.icp) call warn (94,r,i,n4name)

         rewind (99)
10       read (99,1000,end=99) bigrec
         write (nps,1000) bigrec
         goto 10

      end if  
 
1000  format (a)
1010  format (10a8)
1030  format (8a10)
1040  format (20a5)
1050  format (10(g12.6,1x))
1060  format (20(i6,1x))
1100  format (/,'convert ',a,' to activity (or fugacity) (y/n)?')
1110  format (/,'the converted variable will be named: ',a,/,'and ',
     *        'is the base 10 log of the activity (or fugacity).',/)
1120  format (3(i1,1x),6(g12.6,1x))


99    end


c---------------------------------------------------------------
      subroutine mcurv (iend)

c pscurv - subroutine to output curves.

      implicit double precision (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      integer  idr, jap(2), iaid(2)
 
      double precision xy(l5,2)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ rxn /vnu(k7),idr(k7),ivct,iplus(k7),iminus(k7)
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ basic /n4,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)
     *      / cst74 /idbk(k5,k2),jvar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2)
     */ cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     */ cst78 /vcpd(2,k2),icpd(k2),vpha(2,k3),ipha(k3),lex(k2)
     */ cst79 /prmn(k3),prmx(k3),rcps(k7),ibad(k2),icps(k7),kcx,lcx,jcx1
     */ cst80 /tmn(k3),tmx(k3)/ vs /vmin(l3),vmax(l3),iv
     */ cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     */ cst5  /p,t,xco2,u1,u2,tr,pr,r,ps

      iend = 0

10    read (n4,*,end=100) ipt,ird,ivar,ivct,(idr(i),i=1,ivct),iaid,jap 
      read (n4,*) (vnu(i),i=1,ivct)
      write (99,1080) ipt,ird,ivar,ivct,(idr(i),i=1,ivct),iaid,jap 
      write (99,1090) (vnu(i),i=1,ivct)
 
      if (ipt.eq.1) then
         goto 99
      else if (ipt.eq.0) then
         goto 10
      end if

      ipr = ipt/2

      if (ird.gt.k2) then
         write (*,1000) k2
         stop
      end if

      if (ipr.gt.l5*2) then
         write (*,*) ' increase l5 in perplex_parameters.h'
         stop
      end if
 
      read (n4,*) ((xy(i,j),j=1,2),i=1,ipr)

      do i = 1, ipr

         call mcnver (xy(i,1),xy(i,2))

      end do 

      write (99,1070) ((xy(i,j),j=1,2),i=1,ipr)
 
      goto 10

100   write (*,1010) 
      iend = 1
1000  format ('Too many reactions, increase parameter k2 (',
     *       i4,') in routine pscurv',/)
1010  format ('End-of-file! if this is a PeRpLeX file ',
     *        'then the PeRpLeX program terminated incorrectly',/)
1070  format (1x,g12.6,1x,g12.6,2x,g12.6,1x,g12.6,2x,g12.6,1x,g12.6)
1080  format (16(i5,1x))
1090  format (12(g12.6,1x)) 

99    end

      subroutine mcnver (x,y)

      implicit double precision (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      double precision xy(2), g(2)
 
      common / basic /n4,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)
     *       / cst5  /p,t,xco2,u1,u2,tr,pr,r,ps
     *       / vs    /vmin(l3),vmax(l3),iv
     *       / cst316 /c0,c1,c2,c3,c4,iind,idep

      xy(1) = x
      xy(2) = y
c                                     set p/t if necessary
      if (jpv.lt.3) then
         p = xy(jpv)
         if (idep.ne.0) t = depvar(p)
      else if (jtv.lt.3) then 
         t = xy(jtv)
         if (idep.ne.0) p = depvar(t)
      end if 
c                                     get gees
      call gees (g) 
c                                     convert coordinates
      do j = 1, jvct
         jj = jcv(j)
         xy(jj) = (xy(jj)-g(j))/r/t/2.302585093d0

         if (xy(jj).lt.vmin(jj)) vmin(jj) = xy(jj)
         if (xy(jj).gt.vmax(jj)) vmax(jj) = xy(jj)           
               
      end do 

      x = xy(1)
      y = xy(2)

      end 

c---------------------------------------------------------------
      subroutine mipts 
 
c psipts - subprogram to output invariant points.

      implicit double precision (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      double precision x, y
 
      integer ipds(k5+2)

      common / basic /n4,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)

 
      read (n4,*) ipct, incts
      write (99,1000) ipct, incts
 
      if (ipct.eq.0) goto 99
 
      do i = 1, ipct
         read (n4,*) ipid,ipvar,(ipds(j), j=1,incts),x,y
         write (99,1000) ipid,ipvar,(ipds(j), j=1,incts)
         call mcnver (x,y)
         write (99,1060) x,y
      end do
 
1000  format (14(i5,1x))
1060  format (5(1x,g12.6))

99    end

c-------------------------------------------------------------------
      subroutine mplinp (n4name,jcomp)

c subroutine to read bulk composition data file for pseudosections.

      implicit double precision (a-g,o-z),integer (h-n)

      character*100 n4name, n5name, n6name
 
      include 'perplex_parameters.h'

      common / basic /n4,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)
     *       / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *                iflug(k5,k2)
     *       / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *       / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *       / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *       / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *       / cst12 /cp(k5,k1)/ vs    /vmin(l3),vmax(l3),iv
     *       / cst20 /comps(k1,k5),atwt(k5),icomp
     *       / cst315 /jcont
     *       / cst319 /iemod(k2),kmod 

      n5 = n4 + 2
      n6 = n5 + 1
      ibulk = 1

      if (icopt.eq.5.and.(jpv.lt.3.or.jtv.lt.3)) then
         if (jpv.lt.3.and.jpv.gt.0) call warn (93,r,n4,n5name)
         if (jtv.lt.3.and.jtv.gt.0) call error (93,r,n4,n5name)
      end if 
c                                    open assemblage information
c                                    file = 'b' + plot file name.
      n5name = n4name 
      call inblnk (n5name,'b')
      open (n5,err=90,file=n5name,status='old')
      n6name = n4name
      call inblnk (n6name,'m')
      call inblnk (n6name,'b')
      open (n6,file=n6name,status='unknown')

10    read (n5,*,end=20) jd, ivar(ibulk), iap(ibulk), iflu(ibulk),
     *                   (idbk(i,ibulk), i = 1, jbulk)
      read (n5,*) (vr(i,ibulk), i = 1, iv-jcont)
      read (n5,*) ((props(j,i,ibulk), j = 1, 11), i = 1, jbulk)
      read (n5,*) (ptot(j,ibulk), j = 1, 7),btot(ibulk),gtot(ibulk),
     *            (fbulk(j,ibulk), j = 1, jcomp)

      if (iflu(jd).eq.1) then 
         read (n5,*) (iflug(j,ibulk), j = 1, jbulk)
         read (n5,*) (ptot1(j,ibulk), j = 1, 7),
     *        btot1(ibulk),gtot1(ibulk),(fbulk1(j,ibulk), j = 1, icomp)
      end if

      if (kmod.ne.0) then 
         read (n5,*) iemod(ibulk)
         if (iemod(ibulk).ne.0) read (n5,*) 
     *     ((props(j,i,ibulk), j= 12, 14), i = 1, jbulk)
      end if

      write (n6,*) jd, ivar(ibulk), iap(ibulk), iflu(ibulk),
     *                   (idbk(i,ibulk), i = 1, jbulk)
      write (n6,*) (vr(i,ibulk), i = 1, iv-jcont)
      write (n6,*) ((props(j,i,ibulk), j = 1, 11), i = 1, jbulk)
      write (n6,*) (ptot(j,ibulk), j = 1, 7),btot(ibulk),gtot(ibulk),
     *            (fbulk(j,ibulk), j = 1, jcomp)
      if (iflu(jd).eq.1) then 
         write (n6,*) (iflug(j,ibulk), j = 1, jcomp)    
         write (n6,*) (ptot1(j,ibulk), j = 1, 7),
     *        btot1(ibulk),gtot1(ibulk),(fbulk1(j,ibulk), j = 1, jcomp)
      end if 

      if (kmod.ne.0) then 
         write (n6,*) iemod(ibulk)
         if (iemod(ibulk).ne.0) write (n6,*) 
     *     ((props(j,i,ibulk), j= 12, 14), i = 1, jbulk)
      end if

      goto 10

20    close (n5)
      close (n6) 

      goto 99 

90    write (*,1000) n5name,n4name
      stop

1000  format (/,'The bulk information file:',/,a,/,'corresponding to'
     *         ,' the plot file:',/,a,/,'Does not exist.',//)

99    end   
 
      subroutine mudata
c  
      call fopen
 
      call input2 

      end 

      subroutine input2 
c----------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-m)
 
      include 'perplex_parameters.h'
 
      character*5 cmpnt, tname, dname*40
      character*8 name, exname, vname, y*1

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
 
      common/ cst1  /thermo(k4,k10),uf(2),us(h5)
     *      / cst24 /ipot,jv(l2),iv1,iv2,iv3,iv4,iv5
     *      / cst25 /vnu(k5+1),idr(k5+1),ivct/ cst205 /act(k5+1),idf(2)
     *      / cst201 /vuf(2),vus(h5),iffr,isr/ oxy /io2
     *      / cst10 /iff(2),idss(h5),ifug,ifyn,isyn
     *      / cst6 /icomp,istct,iphct,icp/ cst36 /exname(h8)
     *      / cst5  /p,t,xco2,u1,u2,tr,pr,r,ps/ csta6 /name
     *      / cst37 /ixct,iexyn/ cst12 /cp(k5,k1)
     *      / cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9
     *      / csta5 /dname(8),cmpnt(k0)/ cst42 /ic(k5),idbase
     *      / cst43 /therm(k4),comp(k0),atwt(k0),idh2o,idco2,ikind
     *      / cst202 /tm(m7,m6),td(m8),ilam,idiso,lamin,idsin
     *      / cst203 /therdi(m8,m9),therlm(m7,m6,k9)
     *      / cst204 /ltyp(k1),lmda(k1),idis(k1)/ cst60 /ipoint,imyn
     *      / csta10 /tname(2)
      common/ basic /nin,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)

c---------------------------------------------------------------------
      rewind n2
 
      call topn2 (1,icmpn)

      jmyn = 1
      isyn = 1
      jf(1) = 0
      jf(2) = 0

      icomp = icmpn
c                               check to avoid overloading cp in loadit
      if (icomp.gt.k5) icomp = k5

      do i = 1, icomp
         ic(i) = i 
      end do 
c                               list database phases:
      write (*,1030)
      read (*,5000) y
      if (y.ne.'y'.and.y.ne.'Y') goto 5
      write (*,3000) (cmpnt(i),i=1,icmpn)

300   call getphi (name,ibase,icmpn,*5)
c                               reject wrong data base cards:
      if (idbase.ne.ibase) goto 300
c                               acceptable data, count the phase
      write (*,3010) name, (comp(i),i=1,icmpn)
 
      goto 300
c                               begin the real work:
c                               initialize:
5     iphct=0
      ifyn = 1
c
      do 10 i= 1, jvct

30       write (*,1040) vname(jcv(i)),tname(jcv(i))
         read (*,5000) exname(1)
         if (exname(1).eq.' ') exname(1) = tname(jcv(i))
c                               general input data for main program
         rewind n2

         call eohead (n2)
 
220      call getphi (name,ibase,icmpn,*999)
c                               reject wrong data base cards:
         if (idbase.ne.ibase) goto 220
c                               acceptable data, count the phase
         if (exname(1).ne.name) goto 220

         iphct = iphct + 1

      if (exname(1).eq.cmpnt(idh2o)) then
         write (*,1050) vname(jcv(i))
         read (*,'(a)') y
         if (y.eq.'y'.or.y.eq.'Y') then 
            ifyn=0
            jf(i) = 1
         end if 
      else if (exname(1).eq.cmpnt(idco2)) then
         write (*,1050) vname(jcv(i))
         read (*,'(a)') y
         if (y.eq.'y'.or.y.eq.'Y') then 
            ifyn=0
            jf(i) = 2
         end if 
      end if
c                               store thermodynamic parameters:
         call loadit (iphct)

         ipoint = iphct
c                               next phase:
         goto 10
 
999      write (*,4050)
         goto 30
10    continue

      if (ifyn.eq.0) call rfluid (1,ifug,n3)

1000  format (3(a8,18x))
1020  format (a8,i2,i2,i2,i2)
1030  format (/,'List database phases (y/n)? ')
1040  format (/,'Select a phase or species to be used to define ',
     *        a,'(default =',a,')')
1050  format (/,'Compute ',a,' as an activity (y/n)? ')
3000  format (t30,'composition',/,' phase',4x,30(a,1x))
3010  format (1x,a,1x,30(f5.2,1x))
4050  format ('invalid name, try again.',/)
5000  format (a)
 
9999  end

      block data
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-m)
 
      character*28 list
 
      common/ cst5 /p,t,xco2,u1,u2,tr,pr,r,ps/ cst85 /pp,tt,yy,rr
     *      / cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9
     *      / cst206 /list(20)
c-----------------------------------------------------------------------
      data r,rr/8.3144126d00,83.14/
c                              the following data statement assigns
c                              logical unit numbers for i/o.
      data n1,n2,n3,n4,n5,n6,n7,n8,n9/21,22, 6,24,25,26, 5, 6,29/
c
      data list /'standard free energy g (j)  ',
     *           'standard entropy s (j/k)    ',
     *           'standard volume v (j/bar)   ',
     *           'heat capacity coefficient a ',
     *           'heat capacity coefficient b ',
     *           'heat capacity coefficient c ',
     *           'heat capacity coefficient d ',
     *           'heat capacity coefficient e ',
     *           'heat capacity coefficient f ',
     *           'heat capacity coefficient g ',
     *           'volumetric coefficient b1   ',
     *           'volumetric coefficient b2   ',
     *           'volumetric coefficient b3   ',
     *           'volumetric coefficient b4   ',
     *           'volumetric coefficient b5   ',
     *           'volumetric coefficient b6   ',
     *           'volumetric coefficient b7   ',
     *           'volumetric coefficient b8   ',
     *           'activity                    ',
     *           'reaction coefficient        '/
      end
 
      subroutine fopen
c--------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-m)
 
      character*100 n2name,yes*1
 
      common/ cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9
      common/ cst41a /n2name
c---------------------------------------------------------------------
c                                 first the thermo data file
1     write (n8,1000)
      read (*,'(a)') n2name
      if (n2name.eq.' ') n2name = 'hp01ver.dat'
      open (n2,file=n2name,iostat=ierr,status='old')
      if (ierr.ne.0) then
c                                 system could not find the file
         write (*,1010) n2name
         write (*,1040)
         read (*,'(a)') yes
         if (yes.ne.'y'.and.yes.ne.'Y') goto 999
         goto 1
c                                 try again
      end if
 
      return
 
999   write (*,1050)
 
      stop
 
1000  format (/,'Enter the thermo data file name, left justified,'
     *         ,' < 100 characters, (default = hp01ver.dat):')
1010  format (/,'**error ver191** fopen cannot find file:',/,a,/)
1040  format (/,'Try again (y/n)? ')
1050  format (/,'o.k., then i quit too.',/)
      end
 

      subroutine gees (g)
c--------------------------------------------------------------------
      implicit double precision (a-g,o-y),integer (h-m)
 
      include 'perplex_parameters.h'

      double precision g(2)
 
      common/ cst5 /p,t,xco2,u1,u2,tr,pr,r,ps
     *      / cst10 /iff(2),idss(h5),ifug,ifyn,isyn
     *      / cst6  /icomp,istct,iphct,icp/ cst11 /fh2o,fco2
     *      / basic /nin,nps,jcv(2),jvct,icopt,jpv,jtv,jf(2)
c---------------------------------------------------------------------
c                                 compute free energy change of the rxn
      call updumy
 
      do j = 1,iphct
         call gphase (j,gph)
         g(j) = gph
         if (jf(j).eq.1) then 
            xco2 = 0d0
            call cfluid (fo2,fs2)
            g(j) = g(j) + r*t*fh2o
         else if (jf(j).eq.2) then
            xco2 = 1d0
            call cfluid (fo2,fs2)
            g(j) = g(j) + r*t*fco2
         end if 
      end do 
      end

      subroutine grxn (g)
      implicit double precision (a-g,o-y),integer (h-m)
c                                dummy routine for rlib
      end 