c THE PTOT ARRAYS ARE REDUNDANT AND SHOULD BE DELETED, the only
c variables used from these arrays are ptot(1) -> total number of 
c moles of the components per unit system, and ptot(2) -> the 
c molar weight per unit system.

c physical property arrays in plib.f routines:

c the basic properties from vertex are in the arrays props, ptot, ptot1

c props(np,k5,k2) for the k5'th compund of the k2'th assemblage,
c np is the physical property as follows:

c    1 - molar proportion
c    2 - atwt (g)
c    3 - molar enthalpy (J)
c    4 - volume (J/bar)
c    5 - Cp (J/K)
c    6 - dV/dT (J/bar/K)
c    7 - dV/dP (J/bar/bar)
c    8 - d2V/dT2
c    9 - (dV/dT)/dP
c   10 - d2V/dP2
c   11 - S (J/K) replaced d3V/dT3 as of 5/31/04
c   12 - shear modulus
c   13 - temperature derivative of the shear modulus
c   14 - pressure derivative of the shear modulus

c iflu(k2) = 1 if fluid present, otherwise = 0.

c additionally we have the following proportions and bulk properties:

c  ptot(1,k2)  - aggregate total moles
c  ptot(2,k2)  - aggregate total weight

c  ptot1(1,k2) - aggregate-fluid total moles
c  ptot1(2,k2) - aggregate-fluid total weight


c from these routine seismo computes the following properties as 
c a function of pressure and temperature:

c in array pphi(j,k5) for each cpd:

c 1 - vphi(k5)   - cpd volume 
c 2 - ephi(k5)   - cpd enthalpy 
c 3 - grunp(k5)  - cpd gruenesien ratio
c 4 - bulkmp(k5) - cpd adiabatic bulk modulus
c 5 - mup(k5)    - cpd shear modulus
c 6 - vel0p(k5)  - cpd sound velocity 
c 7 - velsp(k5)  - cpd s-wave velocity
c 8 - velpp(k5)  - cpd p-wave velocity
c 9 - vp/vs
c10 - rhop(k5)   - cpd density
c11 - vfract(k5) - cpd volume fraction
c12 - cp
c13 - alpha
c14 - beta 

c in arrays psys(j) and psys1(j)
c (vsys, esys, cp, alpha, beta, rho are calculated by arithmetic mean, the
c values of cp alpha and beta used for seismic props are computed by VRH
c averaging).

c 1 vsys       - sys molar volume 
c 2 esys       - sys molar enthalpy 
c 3 grun       - sys gruenesien ratio
c 4 bulkm      - sys adiabatic bulk modulus
c 5 mu         - sys shear modulus
c 6 vel0       - sys sound velocity 
c 7 velp       - sys p-wave velocity
c 8 vels       - sys s-wave velocity
c 9 vp/vs      
c 10 rsys      - sys density
c 11 csys      - sys specific heat capacity
c 12 cp
c 13 alpha
c 14 beta 

c additionally the total (cpd sum) for a solution can be obtained
c with routine vmodes.

	subroutine amiin (x,y,iam)

c amiin - routine to check if a (x,y) point lies inside a polygon.
c         copy of katja's check inside, assumes last point duplicates
c         first point.

c         alternatively (icopt=5) amiin identifies the assemblage 
c         associated with a grid point.

c         iam - is the polygon id if x-y is bounded otherwise 0.

      implicit real (a-g,o-z),integer (h-n)
 
      include 'perplex_parameters.h'

      common/ polyx /px(l5,k2)/ polyy /py(l5,k2)
     *      / poly /npts(k2),iptoa(k2),ibd(k2),npoly
     *      / cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
     *      / vs     /vmin(l3),vmax(l3),iv
      common/ basic  /n4,ifont,icopt,jwidth,iop0

      if (icopt.eq.5) then 
c                                     find node associated with condition
         del = x-vmin(1)
         ix = del/dx 
         res = del - ix*dx
         if (res.gt.0.5*dx) ix = ix + 1
         ix = ix + 1

         del = y-vmin(2)
         jy = del/dy 
         res = del - jy*dy
         if (res.gt.0.5*dy) jy = jy + 1
         jy = jy + 1

         iam = igrd(ix,jy)

         goto 99

      end if 
c                                     do for each polygon:
      do i = 1, npoly

         if (ibd(i).eq.1) then 
         
            igo = 0

            do j = 1, npts(i) - 1

               if ((y.le.py(j,i).and.y.gt.py(j+1,i)).or. 
     *             (y.gt.py(j,i).and.y.le.py(j+1,i))) then 
	 
                  if (( (py(j+1,i)-py(j,i))*(x-px(j,i))
     *                - (px(j+1,i)-px(j,i))*(y-py(j,i)) )
     *                * (py(j+1,i)-py(j,i)) .lt. 0e0) igo = iabs(igo-1)

               end if 
            end do 
c                                      odd number of flips
c                                      the point is inside
            if (igo.eq.1) then 
               iam = iptoa(i)
               goto 99
            end if 
         end if 
      end do 

      iam = 0	

99    end 

      subroutine pplinp (fname)

c pplinp - read polygon file

      implicit real (a-g,o-z),integer (h-n)
 
      character*100 fname,n5name
 
      include 'perplex_parameters.h'

      common / basic /n4,ifont,icopt,jwidth,iop0
     *       / polyx /px(l5,k2)/ polyy /py(l5,k2)
     *       / poly /npts(k2),iptoa(k2),ibd(k2),npoly

      n5 = n4 + 1
c                                    open polygon file = 'p' + plot file name.
      n5name = fname 
      call inblnk (n5name,'p')
      open (n5,file=n5name,status='old')
      read (n5,*,end=90) npoly,ncoor

      if (npoly.gt.k2) then 
         write (*,1000) npoly,k2
         stop
      else if (ncoor.gt.l5) then 
         write (*,1010) ncoor,l5
         stop
      end if 

      do i = 1, npoly
         read (n5,*,end=90) npts(i),iptoa(i),ibd(i)
         npts(i) = npts(i)/2
         read (n5,*) (px(j,i), py(j,i), j = 1, npts(i))
      end do 

      goto 99

90    write (*,1020) n5name,fname
      stop

1000  format (/,'Too many polygons (',i5,') increase parameter k2 (',
     *        i5,' and recompile WERAMI',/)
1010  format (/,'Too many coordinates in a polygon (',i5,') increase',
     *          ' parameter l5 (',i5,') and recompile WERAMI',/)
1020  format (/,'Inconsistent polygon file:',/,a,/
     *          'You have not run POLYGON since generating ',/,a,/,
     *          'with VERTEX, or POLYGON terminated abnormally.',/)
99    end 

      subroutine plinp (tmin,tmax,pmin,pmax)
 
c plinp - subroutine to read x-y plot file header.

      implicit real (a-g,o-z),integer (h-n)
 
      character*8 tname*162,vname,names,sname*10,cname*5
 
      include 'perplex_parameters.h'

      integer iopt

      real nopt 

      double precision dblk(3,k5)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
     *      / cst319 /iemod(k2),kmod  
      common/ cst8  /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
     *      / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / basic /n4,ifont,icopt,jwidth,iop0
     *      / csta4 /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
     *      / cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
     *      / cst310 /tname(4)/ cst315 /jcont/ cst321 /interp 
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep
      common/ opts /iopt(10),nopt(10)

      jcont = 0 
      interp = 0
      iind = 0
      read (n4,*,err=91) icopt

      if (icopt.eq.7.or.icopt.eq.9) then 
c                               interp = 1, turn
c                               interpolation off for
c                               fractionation calcs.
         interp = 1
         iopt(4) = 1
         write (*,3000) 

      end if 

      read (n4,*) iphct, isoct, icomp
      read (n4,*) jbulk, ivol, icp, jvol, kmod
      if (icomp.ne.0) then
         read (n4,1040) (cname(i), i = 1, icomp)
         read (n4,*) (atwt(i), i = 1, icomp)
      end if 
      if (iphct.ne.0) then
         if (iphct.gt.k1) then 
            write (*,*) '**error** too many pseudocompounds, ',
     *                  'increase parameter k1.'
            stop
         end if 
         read (n4,1010) (names(i),i = 1, iphct)
         read (n4,*) ((comps(i,j), j= 1, icomp), i = 1, iphct)
         read (n4,*) (ikp(i), i = 1, iphct)
      end if
      if (isoct.ne.0) read (n4,1030) (sname(i), i = 1, isoct) 
      read (n4,1000) tname
      read (n4,*) iv,(jv(i),i=1,iv),jpt
      read (n4,*) jcont,iind,idep,c0,c1,c2,c3,c4
      read (n4,*) (vmax(i),vmin(i),i=1,iv)
      read (n4,1000) (vname(i),i=1,iv)
c                              turn interpolation off if only
c                              compositional variables:
      if (jcont.ne.0) interp = 1

      if (icopt.eq.5.or.icopt.eq.7.or.icopt.eq.9) then 
c                                       compositions
         if (jcont.gt.0) read (n4,*) 
     *                   ((dblk(i,j),j=1,jbulk),i=1,jcont+1)
c                                       grid plot file
         if (icopt.eq.5) then 
c                                       normal grid
            read (n4,*) loopx, loopy, jinc
         else if (icopt.eq.7) then 
c                                       1-d fractionation
            read (n4,*) loopx, loopy
            jinc = 1
         else 
c                                       2-d fractionation
            read (n4,*) loopx, loopy, zbox
            jinc = 1
         end if 

         if (loopx.eq.1) then
            write (*,1060) vmin(1)
            vmax(1) = vmin(1) + 1d0
            dx = 2d0
         else 
            dx = (vmax(1) - vmin(1))/float(loopx-1)
         end if 

         if (icopt.eq.9) then 
            vmin(2) = 0d0
            vmax(2) = zbox*(loopy-1)
         end if 

         dy = (vmax(2) - vmin(2))/float(loopy-1)
c                                       decompress the grid data
         do i = 1, loopx
            jst = 1
            do while (jst.le.loopy)
               read (n4,*) irep, kd
               jend = jst + irep 
               do j = jst, jend
                  igrd(i,j) = kd
               end do 
               jst = jend + 1
            end do 
         end do 
c                                       now look for bad uns:
         do i = 2, loopx
            do j = 2, loopy
               
               if (igrd(i,j).ne.0.and.igrd(i,j).ne.1) cycle

               if (igrd(i,j).eq.1) then 
                  if (igrd(i,j-1).eq.1.or.igrd(i,j+1).eq.1.or. 
     *                igrd(i-1,j).eq.1.or.igrd(i+1,j).eq.1.or.            
     *                igrd(i+1,j+1).eq.1.or.igrd(i-1,j-1).eq.1.or. 
     *                igrd(i-1,j+1).eq.1.or.igrd(i+1,j-1).eq.1) cycle
               end if
               igrd(i,j) = igrd(i,j-1)
               write (*,*) 'reset a bad un at ',i,j
            end do 
         end do 

         icopt = 5

      end if           
c                                       for polygon:
      jcopt = icopt 

      tmin = vmin(1)
      tmax = vmax(1)
      pmin = vmin(2)
      pmax = vmax(2)

      goto 99

91    write (*,1050)
      stop

1000  format (a)
1010  format (10a8)
1030  format (8a10)
1040  format (20a5)
1050  format (/,'The plot-file is not formatted correctly.',/)
1060  format (/,'**warning** you are plotting a 1-dimensional grid ',
     *        'as a 2-dimensional',/,'plot. The width of the X-axis ',
     *        'is arbitrary, the assigned value for the X-axis',/,
     *        'variable is: ',g12.6,/)
1070  format (/,'Enter the VERTEX plot file name: ')
3000  format (/,'**warning ver636** For this computational mode ',
     *          'interpolation of physical',/,'properties has been ',
     *          'turned OFF.',/)

99    end

c-------------------------------------------------------------------
      subroutine bplinp (fname,kpoly)

c subroutine to read bulk composition data file for pseudosections.

c props(np,k5,k2) for the k5'th compund of the k2'th assemblage,
c np is the physical property as follows:

c    2 - atwt (g)
c    3 - molar enthalpy (J)
c    4 - volume (J/bar)
c    5 - Cp (J/K)
c    6 - dV/dT (J/bar/K)
c    7 - dV/dP (J/bar/bar)
c    8 - dCp/dT
c    9 - dCp/dP
c   10 - d2V/dT2
c   11 - (dV/dT)/dP
c   12 - (dV/dP)/dT
c   13 - dV2/dP2
c   14 - shear modulus
c   15 - temperature derivative of the shear modulus
c   16 - pressure derivative of the shear modulus

c iflu(k2) = 1 if fluid present, otherwise = 0.

c additionally we have the following proportions and bulk properties:

c  ptot(1,k2)  - aggregate total moles
c  ptot(2,k2)  - aggregate total weight
c  ptot(4,k2)  - aggregate total volume
c  ptot1(1,k2) - aggregate-fluid total moles
c  ptot1(2,k2) - aggregate-fluid total weight
c  ptot1(4,k2) - aggregate-fluid total volume

c from these we can define 

c props(1,i,jd)/ptot(1,jd)                 - compound mol fraction 
c props(1,i,jd)*props(2,i,jd)/ptot(2,jd)   - compound wt fraction
c props(1,i,jd)*props(4,i,jd)/ptot(4,jd)   - compound volume fraction


      implicit real (a-g,o-z),integer (h-n)

      character*100 fname, n5name
 
      include 'perplex_parameters.h'

      integer kdsol(k5), inew, kp, jp, lp, nscpd,  
     *        ldsol(k5), idnew(k2), iass(k3),iopt

      real nopt

      common/ basic /n4,ifont,icopt,jwidth,iop0
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ phase /ikp(k1)
     *      / vs    /vmin(l3),vmax(l3),iv/ cst315 /jcont   
     *      / cst319 /iemod(k2),kmod/ opts /iopt(10),nopt(10)
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep
     *      / cst326 /np(k2),ncpd(k2),npcpd(k2),idsol(k5,k2)

      n5 = n4 + 1
      ibulk = 1
      inew = 0 
      iapmax = 0 
c                                    open assemblage information
c                                    file = 'b' + plot file name.
      n5name = fname 
      call inblnk (n5name,'b')
      open (n5,err=90,file=n5name,status='old')

10    read (n5,*,end=20) jd, ivar(ibulk), iap(ibulk), iflu(ibulk),
     *                   (idbk(i,ibulk), i = 1, jbulk),
     *                   ijcor(ibulk,1), ijcor(ibulk,2),
     *                   np(ibulk),ncpd(ibulk),
c                                    kdsol is the solution flag, 
c                                    it's not needed so read it 
c                                    into a simple array.
     *                   (kdsol(i), i = 1, np(ibulk)),
     *                   (idsol(i,ibulk),i = 1, np(ibulk))

	if (iind.eq.0) then 
         read (n5,*) (vr(i,ibulk), i = 1, iv - jcont)
	else 
         read (n5,*) (vr(i,ibulk), i = 1, iv - jcont - 1)
	end if 

      read (n5,*) ((props(j,i,ibulk), j = 1, 11), i = 1, jbulk)
      read (n5,*) (ptot(j,ibulk), j = 1, 2),btot(ibulk),gtot(ibulk),
     *            (fbulk(j,ibulk), j = 1, icomp)
      if (iflu(jd).eq.1) then 
         read (n5,*) (iflug(j,ibulk), j = 1, jbulk)
         read (n5,*) (ptot1(j,ibulk), j = 1, 2),
     *        btot1(ibulk),gtot1(ibulk),(fbulk1(j,ibulk), j = 1, icomp)
      end if 
c                              shear moduli are only read as a special case:
      if (kmod.ne.0) then 
         read (n5,*) iemod(ibulk)
         if (iemod(ibulk).ne.0) read (n5,*) 
     *     ((props(j,i,ibulk), j= 12, 14), i = 1, jbulk)
      else 
         iemod(ibulk) = 0
      end if 
c                              default pseusdocompound counter, reset by zero_mode opt.
      npcpd(ibulk) = jbulk
c                              this eliminates the need for the ivar read:
      ivar(ibulk) = jbulk + 2 - np(ibulk) - ncpd(ibulk)
c                              this eliminates the need for the ptot1(2) reads:
      if (iflu(jd).eq.1) then 

         ptot1(2,jd) = 0d0

         do i = 1, jbulk 
            if (iflug(i,ibulk).eq.0) then 
c                              atwt of system without fluid:
               ptot1(2,ibulk) = ptot1(2,ibulk) + props(1,i,ibulk)*
     *                                           props(2,i,ibulk)
            end if
         end do 

      end if 
c                              eliminate zero mode phases if 
c                              zero_mode option is off
      if (nopt(9).ge.0d0) then 
c                              find the highest assemblage number.
         if (iapmax.lt.iap(ibulk)) iapmax = iap(ibulk)
         ip = 0 
         kp = 0
         lp = 0  
c                              first count non-zero solutions
         do i = 1, np(ibulk)
            jp = 0 
            do j = 1, idsol(i,ibulk)
               lp = lp + 1
               if (props(1,lp,ibulk).gt.nopt(9)) then
c               if (props(1,lp,ibulk).gt.1d-4.or.
c     *             iflug(i,ibulk).ne.0) then
                  ip = ip + 1
                  jp = jp + 1
                  kdsol(ip) = lp
               end if 
            end do 
            if (jp.ne.0) then 
               kp = kp + 1
               ldsol(kp) = jp
            end if 
         end do

         nscpd = ip
c                              the non zero pseudocompounds are 
c                              in kdsol, the counter per solution is
c                              in ldsol and kp is the number of 
c                              non-zero solutions.

c                              now count compounds:
         jp = 0 
         do i = lp+1, lp+ncpd(ibulk)             
            if (props(1,i,ibulk).ne.0d0) then
               jp = jp + 1
               kdsol(nscpd+jp) = i
            end if
         end do
c                              ok, now reassign props
         jflug = 0
         do i = 1, nscpd + jp
            idbk(i,ibulk) = idbk(kdsol(i),ibulk)
            iflug(i,ibulk) = iflug(kdsol(i),ibulk) 
            if (iflug(i,ibulk).ne.0) jflug = 1
            do j = 1, 14
               props(j,i,ibulk) = props(j,kdsol(i),ibulk)
            end do 
         end do

         if (iflu(jd).ne.0.and.jflug.eq.0) iflu(jd) = 0 

         np(ibulk) = kp
         ncpd(ibulk) = jp
         npcpd(ibulk) = nscpd + jp
         ivar(ibulk) = jbulk + 2 - np(ibulk) - ncpd(ibulk)
c                              load solution cpd counters:
         do i = 1, kp
            idsol(i,ibulk) = ldsol(i)
         end do 
c                              save index for reclassification
         if (nscpd+jp.lt.jbulk) then 
            inew = inew + 1
            idnew(inew) = ibulk
         end if 
      end if 

      ibulk = ibulk + 1
      goto 10

20    close (n5)
c                               now reclassify new assemblages
      if (inew.ne.0) then 
         iapmin = iapmax + 1
         iapmax = iapmax + 1
         iap(idnew(1)) = iapmax 
         if (inew.eq.1) goto 30
c                               classify the assemblage by saving
c                               an index
         iass(iapmax) = idnew(1)


         do 70 i = 2, inew 
            id = idnew(i)
            do 50 j = iapmin, iapmax
               jd = iass(j)
               if (np(jd).eq.np(id).and.ncpd(jd).eq.ncpd(id)) then
c                               first match solutions 
                  do 40 k = 1, np(id)
                     do l = 1, np(id)
                        if (ikp(idbk(k,id)).eq.ikp(idbk(l,jd))) goto 40
                     end do
c                               failed to match a solution, next assemblage
                     goto 50  
40                continue 
c                               now match compounds
                  do 60 k = npcpd(id)-ncpd(id)+1, npcpd(id)
                     do l = npcpd(id)-ncpd(id)+1, npcpd(id)
                        if (idbk(k,id).eq.idbk(l,jd)) goto 60 
                     end do 
c                               failed to match a pseudocompound, next assemblage
                     goto 50 
60                continue 
c                               if here we matched assemblage j
                  iap(id) = j  
                  goto 70 
               end if 
50          continue  
c                               if here id's a new assemblage
            iapmax = iapmax + 1
            iass(iapmax) = idnew(i)
70       continue  

         write (*,*) iapmax-iapmin,' new assemblages'

      end if 

30    ibulk = ibulk - 1
c                                    open polygon file = 'p' + plot file name.

      kpoly = ibulk 

      goto 99 

90    write (*,1000) n5name,fname
      stop

1000  format (/,'The bulk information file:',/,a,/,'corresponding to'
     *         ,' plot file:',/,a,/,'does not exist.',//)

99    end   
c-------------------------------------------------------------------
      subroutine calpr1 (x,y,jd,n3) 

c calprp - compute full vertex style print output from b-plot file.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      character cname*5, pname(k5)*20, vname*8, cprop*18

      integer iopt

      real x, y, nopt

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ csta4  /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
      common/ basic /n4,ifont,icopt,jwidth,iop0/ cst315 /jcont 
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep/ opts /iopt(10),nopt(10)
     *      / cst324 /scomps(k5,k5),pcomp(k5,k5)
     *      / cst322 /cwt(k5),swt(k5),twt(k5)
c                                      determine if x and/or y are 
c                                      pressure or temperature:
      call xytopt (x,y,p,t,dp,dt,jd)   
c                                      compute derivative props:                                    
      call seismo (p,t,dp,dt,jd)

      write (n3,1000) jd 
      write (n3,1120) vname(1), x, vname(2), y 
      if (iv.gt.2) write (n3,1120) (vname(i), vr(i-jcont,jd), i = 3, iv)

      if (iopt(2).eq.0) then 
         cprop = 'molar  proportions'
      else
         cprop = 'weight percentages'
      end if

      write (n3,1020) cprop, (cname(i), i = 1, icomp)

      if (iopt(1).eq.0.or.iopt(1).eq.2) then 
c                                      output without averaging pseudocompounds  
         do i = 1, jbulk
            call blktxt (pname(i),idbk(i,jd),0)
            write (n3,1030) pname(i),  
     *                      props(1,i,jd)*props(2,i,jd)/ptot(2,jd)*1e2,
     *                      pphi(11,i)*1e2,(pcomp(i,l), l = 1, icomp)
         end do 

         write (n3,1160)
c                                     phase/system summary, normal thermo:
         do i = 1, jbulk
c                                     N, H, V, Cp, alpha, beta
            write (n3,1170) pname(i), props(2,i,jd),pphi(2,i),pphi(1,i),
     *                     (pphi(j,i), j = 12, 14), pphi(10,i)
         end do

         write (n3,1170) 'System              ',ptot(2,jd),psys(2),
     *                psys(1),psys(12),psys(13),psys(14)

         if (iflu(jd).eq.1) 
     *   write (n3,1170) 'System - Fluid      ',ptot1(2,jd),psys1(2),
     *                   psys1(1),psys1(12),psys1(13),psys1(14)

         write (n3,1190)
c                                     phase/system summary, seismic:
         do i = 1, jbulk
            write (n3,1200) pname(i), (pphi(j,i), j = 3, 8) 
         end do
      end if 

      if (iopt(1).eq.1.or.iopt(1).eq.2) then 
c                                      output with averaging
         do i = 1, nphi
            k = idphi(i)
            call blktxt (pname(i),k,1)
            write (n3,1030) pname(i),  
     *                      swt(i)/ptot(2,jd)*1e2,
     *                      sphi(11,i)*1e2,(scomps(i,l), l = 1, icomp)
         end do 

         write (n3,1160)
c                                     phase/system summary, normal thermo:
         do i = 1, nphi
c                                     N, H, V, Cp, alpha, beta
            write (n3,1170) pname(i), swt(i)/twt(i),sphi(2,i),sphi(1,i),
     *                  (sphi(j,i), j = 12, 14), sphi(10,i)
         end do

         write (n3,1170) 'System              ',ptot(2,jd),psys(2),
     *                psys(1),psys(12),psys(13),psys(14)

         if (iflu(jd).eq.1) 
     *   write (n3,1170) 'System - Fluid      ',ptot1(2,jd),psys1(2),
     *                   psys1(1),psys1(12),psys1(13),psys1(14)

         write (n3,1190)
c                                     phase/system summary, seismic:
         do i = 1, nphi
            write (n3,1200) pname(i), (sphi(j,i), j = 3, 8) 
         end do

      end if 


      if (iflu(jd).eq.0) then 
c                                     no fluid is present:
         write (n3,1210)

         write (n3,1040)

         do i = 1, icomp

            write (n3,1110) cname(i),fbulk(i,jd), 
     *                      fbulk(i,jd)/gtot(jd)*1e2,
     *                      fbulk(i,jd)*atwt(i)/btot(jd)*1e2                            
         end do

         write (n3,1220)

         write (n3,1060) psys(10), 
c                                     enthalpy, specific enthalpy
     *                   psys(2)/psys(1)*1d5/psys(10),
     *                   psys(2)/psys(1)*1d5, 
c                                     entropy, specific entropy 
     *                   psys(15)/psys(1)*1d5/psys(10),
     *                   psys(15)/psys(1)*1d5,
c                                     cp, specific cp 
     *                   psys(12)/psys(1)*1d5/psys(10),
     *                   psys(12)/psys(1)*1d5,(psys(j),j= 3, 8)

      else 
c                                     fluid is present
         write (n3,1210)

         write (n3,1080)

         do i = 1, icomp

            write (n3,1110) cname(i),fbulk(i,jd),
     *                  fbulk(i,jd)/gtot(jd)*1e2,
     *                  fbulk(i,jd)*atwt(i)/btot(jd)*1e2,
     *                  fbulk1(i,jd)/gtot1(jd)*1e2,
     *                  fbulk1(i,jd)*atwt(i)/btot1(jd)*1e2          
         end do

         write (n3,1220)
c                                     true bulk properties:
         write (n3,1060) psys(10), 
c                                     enthalpy, specific enthalpy
     *                   psys(2)/psys(1)*1d5/psys(10),
     *                   psys(2)/psys(1)*1d5, 
c                                     entropy, specific entropy 
     *                   psys(15)/psys(1)*1d5/psys(10),
     *                   psys(15)/psys(1)*1d5,
c                                     cp, specific cp 
     *                   psys(12)/psys(1)*1d5/psys(10),
     *                   psys(12)/psys(1)*1d5,(psys(j),j= 3, 8)
c                                      solid only bulk properties:
         write (n3,1100) psys1(10), 
c                                     enthalpy, specific enthalpy
     *                   psys1(2)/psys1(1)*1d5/psys1(10),
     *                   psys1(2)/psys1(1)*1d5, 
c                                     entropy, specific entropy 
     *                   psys1(15)/psys1(1)*1d5/psys1(10),
     *                   psys1(15)/psys1(1)*1d5,
c                                     cp, specific cp 
     *                   psys1(12)/psys1(1)*1d5/psys(10),
     *                   psys1(12)/psys1(1)*1d5,(psys1(j),j= 3, 8)

         write (n3,1230) 

      end if 

      write (n3,1070) 2, ivar(jd)

      if (idep.eq.0) then 
c                                      pressure and temperature are independent
         write (n3,1180) vname(jpt(1)),vr(jpt(1)-jcont,jd),
     *                   vname(jpt(2)),vr(jpt(2)-jcont,jd)

      else if (idep.eq.1) then 
c                                      pressure is dependent
         write (n3,1185) vname(jpt(2)),vr(jpt(2)-jcont,jd)
      else if (idep.eq.2) then 
c                                      temperature is dependent
         write (n3,1185) vname(jpt(1)),vr(jpt(1)-jcont,jd)
      end if 

1000  format (' ---------',/,1x,'(',i6,') Stable phases at:')
1020  format (/,46x,'Phase Compositions (',a,'):',
     *        /,26x,'wt %',4x,'vol % (2)',3x,20(a,3x))
1030  format (1x,a20,3x,2(f6.2,4x),20(f6.2,2x))
1040  format (/,14x,'mol',7x,'mol %',6x,'wt %')
1050  format (/,'WARNING - negative mass indicates the bulk'
     *         ,' composition is',/,'inconsistent with the'
     *         ,' saturation constraints',/)
1060  format (/,'Density (kg/m3) (2) = ',f7.1,/, 
     *          'Enthalpy (J/kg) (2) = ',g12.6,/,
     *          'Specific Enthalpy (J/m3) (2) = ',g12.6,/,
     *          'Entropy (J/K/kg) (2) = ',g12.6,/,
     *          'Specific Entropy (J/K/m3) (2) = ',g12.6,/,
     *          'Heat Capacity (J/K/kg) (1) = ',g12.6,/,
     *          'Specific Heat Capacity (J/K/m3) (1) = ',g12.6,/,
     *          'Aggregate Grueneisen Ratio (2,3) = ',g12.6,/,
     *          'Aggregate Adiabatic Bulk Modulus (bar) (2,3) = ',g12.6,
     *        /,'Aggregate Shear Modulus (bar) (2,3,4) = ',g12.6,/,
     *          'Aggregate Sound Velocity (km/s) (2,3) = ',g12.6,/,
     *          'Aggregate P-Wave Velocity (km/s) (2,3,4) = ',g12.6,/,
     *          'Aggregate S-Wave Velocity (km/s) (2,3,4) = ',g12.6,/)
1070  format (/,'Variance (c-p+',i1,') = ',i2)
1080  format (/,16x,'Complete Assemblage',15x,'Solid+Melt Only',
     *        /,14x,'mol',7x,' mol %',6x,'wt %',9x,' mol %',6x,'wt %',/)
1100  format (/,'Solid Density (kg/m3) (2) = ',f7.1,/, 
     *          'Solid Enthalpy (J/kg) (2) = ',g12.6,/,
     *          'Solid Secific Enthalpy (J/m3) (2) = ',g12.6,/,
     *          'Solid Entropy (J/K/kg) (2) = ',g12.6,/,
     *          'Solid Specific Entropy (J/K/m3) (2) = ',g12.6,/,
     *          'Solid Heat Capacity (J/K/kg) (1) = ',g12.6,/,
     *          'Solid Specific Heat Capacity (J/K/m3) (1) = ',g12.6,/,
     *          'Aggregate Solid Melt Grueneisen Ratio (2,3) = ',g12.6,/
     *         ,'Aggregate Solid Adiabatic Bulk Modulus (bar) (2,3) = ',
     *  g12.6,/,'Aggregate Solid Shear Modulus (bar) (2,3,4) = ',g12.6,/
     *         ,'Aggregate Solid Sound Velocity (km/s) (2,3) = ',g12.6,/
     *         ,'Aggregate Solid P-Wave Velocity (km/s) (2,3,4) = ',
     *  g12.6,/,'Aggregate Solid S-Wave Velocity (km/s) (2,3,4) = ',
     *                                                          g12.6,/)
1110  format (1x,a8,2x,f8.3,5x,2(f6.2,4x),5x,2(f6.2,4x))
1120  format (29x,a8,' = ',g12.6)
1130  format (20(i5,1x))
1140  format (12(f6.2,1x))
1150  format (12(g14.6,1x))
1160  format (/,25x,'Molar Properties (2):'
     *        /,27x,'N(g)',8x,'H(J)',5x,'V(J/bar)',6x,'Cp(J/K)'
     *         ,6x,'Alpha(1/K)',2x,'Beta(1/bar)',2x,'Density(kg/m3)')
1170  format (1x,a20,1x,f9.2,3x,12(g12.5,1x))
1180  format (/,'Notes:',/,
     *         '1 - Computed at reference condition (',a8,'=',f7.0,
     *         ', ',a8,'=',f5.0,').',/,
     *         '2 - Computed from linearized equation of state',
     *         ' relative to the reference condition.',/,
     *         '3 - Computed by Voigt-Reuss-Hill scheme (e.g., Bina ',
     *         '& Helfrich 1992).',/,
     *         '4 - If zero, shear modulus data is not in the data ',
     *         'base.',/,'---------',/)
1185  format (/,'Notes:',/,
     *         '1 - Computed at reference condition (',a8,'=',f7.0,
     *         ').',/,
     *         '2 - Computed from linearized equation of state',
     *         ' relative to the reference condition.',/,
     *         '3 - Computed by Voigt-Reuss-Hill scheme (e.g., Bina ',
     *         '& Helfrich 1992).',/,
     *         '4 - If zero, shear modulus data is not in the data ',
     *         'base.',/,'---------',/)
1190  format (/,25x,'Seismic (Molar) Properties(2):'
     *        /,24x,'Gruneisen',7x,'Ks(bar)',7x,'Mu(bar)',
     *        4x,'V0(km/s)',5x,'Vp(km/s)',5x,'Vs(km/s)')
1200  format (1x,a20,3x,12(g12.5,1x))
1210  format (/,'Bulk Composition:')
1220  format (/,'Bulk Properties:')
1230  format (/,'N.B.: Aggregate properties represent the entire stable'
     *         ,' assemblage.',/,'Solid aggregate properties represent '
     *         ,'solid and melt properties,',/,'but do not include '
     *         ,'molecular fluid properties.',/)

      end 

      subroutine xytopt (x,y,p,t,dp,dt,jd)
c------------------------------------------------------------------
c this is a routine to determine if the x-y variables of a section
c are pressure and temperature and to calculate the appropriate
c displacements dp and dt from the reference pressure temperature
c conditions for polygon properties. this is sloppy and could be 
c avoided by using the pointer system in vertex
c------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      common/ cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / vs /vmin(l3),vmax(l3),iv/ cst315 /jcont/ cst321 /interp
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep

      dt = 0e0
      dp = 0e0
c                                           jpt points to pressure and temperature
c                                           in the arrays jv, vmin, etc...
c                                           but not to the p and t in the vr array
      if (jpt(1).ne.0) p = vmin(jpt(1))
      if (jpt(2).ne.0) t = vmin(jpt(2))
c                                           first case, idep = 0
c                                           means there P and T are independent
c                                           variables
      if (idep.eq.0) then 

         if (jpt(1).eq.1) then
c                                           pressure is the first (x) variable,
c                                           then jcont must be zero
            dp = x - vr(jpt(1),jd)
            p = x
         else if (jpt(1).eq.2) then
c                                           pressure is the second (y) variable
c                                           in case the first variable is an x
c                                           (jcont=1) shift pointer for vr                                                
            dp = y - vr(jpt(1)-jcont,jd)
            p = y 
         end if

         if (jpt(2).eq.1) then
c                                           temperature is the first (x) variable,
c                                           then jcont must be zero
            dt = x - vr(jpt(2),jd)
            t = x
         else if (jpt(2).eq.2) then
c                                           temperature is the second (y) variable
c                                           in case the first variable is an x
c                                           (jcont=1) shift pointer for vr
            dt = y - vr(jpt(2)-jcont,jd)
            t = y 
         end if 
 
      else
c                                           in this case the user has defined p(t) 
c                                           (idep=1) or t(p) (idep=2).
         if (jcont.eq.1) then
c                                           then if jpt(1)
            if (idep.eq.1.and.jpt(2).eq.3) then
c                                           t is the y variable
               dt = y -  vr(1,jd)
               t = y 
               p = c0 + c1*t + c2*t**2 + c3*t**3 + c4*t**4
               tr = t - dt
               pr = c0 + c1*tr + c2*tr**2 + c3*tr**3 + c4*tr**4 
               dp = p - pr
            else if (idep.eq.2.and.jpt(1).eq.2) then
c                                           p is the y variable
               dp = y -  vr(1,jd)
               p = y 
               t = c0 + c1*p + c2*p**2 + c3*p**3 + c4*p**4  
               pr = p - dp
               tr = c0 + c1*pr + c2*pr**2 + c3*pr**3 + c4*pr**4 
               dt = t - tr
            end if 

         else if (jcont.eq.0) then 
c                                           now the user has a 1d calculation (check fractionation)
c                                           or is using mu or xco2 as a section variable
            if (jpt(1).eq.1.or.jpt(1).eq.2) then 

               pr = vr(jpt(1),jd)

               if (jpt(1).eq.1) then 
c                                           pressure is x
                  p = x
                  dp = x -  pr
               else 
c                                           pressure is y
                  p = y
                  dp = y -  pr
               end if 

               t = c0 + c1*p + c2*p**2 + c3*p**3 + c4*p**4
               tr = c0 + c1*pr + c2*pr**2 + c3*pr**3 + c4*pr**4
               dt = t - tr

            else if (jpt(2).eq.1.or.jpt(2).eq.2) then 
               tr = vr(jpt(2),jd)
               if (jpt(2).eq.1) then 
c                                           temperature is x
                  t = x
                  dt = x -  tr
               else 
c                                           temperature is y
                  t = y
                  dt = y -  tr
               end if 

               p = c0 + c1*t + c2*t**2 + c3*t**3 + c4*t**4
               pr = c0 + c1*tr + c2*tr**2 + c3*tr**3 + c4*tr**4
               dp = p - pr

            end if                                                          
         end if 

      end if 
c                                           if interpolation is
c                                           shut off, set increments to
c                                           zero    
99    if (interp.eq.1) then 
         dp = 0e0
         dt = 0e0
      end if 

      end 


      subroutine blktxt (pname,id,imod)
c-----------------------------------------------------------------------
c subprogram to write a text labels for bulk composition output 
c  id   - phase id
c  imod - 0 -> return solution name + pcompound name
c         1 -> return only solution name
c-----------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      character*8 names, text(20)*1, fname*10, pname*20

      integer imod

      common/ cst8  /names(k1)/ csta7 /fname(h9)/ phase /ikp(k1)    
c                             dump the names into the array text
         if (ikp(id).eq.0) then
c                             simple compound:
            iend = 8
            read (names(id),1000) (text(j), j = 1, iend)
            call ftext1 (text,iend)
            write (pname,1000) (text(j), j = 1, iend)
         else  
c                             solution phases:
            iend = 10
            read (fname(ikp(id)),1000) (text(j), j = 1, 10)
            if (imod.eq.0) then 
               iend = 20
               text(11) = '('
               read (names(id),1000) (text(j), j = 12, 19)
               text(20) = ')'
               call ftext1 (text,iend)
            end if 
            write (pname,1000) (text(j), j = 1, iend)
         end if 

1000  format (20a1)

      end 

      subroutine ftext1 (text,iend)
c-----------------------------------------------------------------------
c subprogram to filter blanks from text 
c-----------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      character*1 text(20)

      itic = 0 

      do i = 1, iend

         if (text(i).ne.' ') then 
            itic = itic + 1
            text(itic) = text(i)
         end if 

      end do 

      iend = itic 
 
      end

      subroutine rerror (ier,*)
c---------------------------------------------------------------------
c rerror - routine to check for errors during list directed i/o
 
      implicit real (a-g,o-z),integer (h-n)
c---------------------------------------------------------------------
 
      if (ier.eq.0) then
         return
      else
         write (*,1000)
         ier = 0
         return 1
      end if
 
1000  format (/,'Your input is incorrect, probably you are using ',
     *        'a character where',/,'you should be using a number ',
     *        'or vice versa, try again...',/)
 
      end

c---------------------------------------------------------------
      subroutine rnam1 (iex,jex)

      implicit real (a-g,o-z),integer (h-n)

      character*10 xnam

      iex = 0
      jex = 0

110   write (*,1040) 
      read (*,1020) xnam

      call matchi (xnam,iex,jex)

      if (iex.eq.-1) then
         write (*,1100) xnam
         goto 110
      end if

      if (iex.eq.0) iex = -1

1020  format (a)
1040  format (/,'Enter solution or compound name (left justified): ')
1100  format (/,'No such entity as ',a,', try again: ')

      end

      subroutine matchi (unnown,itis,icpd)
c----------------------------------------------------------------
 
c matchi - subroutine to determine if the string unnown is a valid
c          solution or compound name.
 
c   itis = 0 if compound, = ikp if solution, and =-1 if invalid
c   icpd = the id of the compound if itis = 0

      implicit real (a-g,o-z),integer (h-n)
 
      character*10 sname, names*8, unnown
 
      include 'perplex_parameters.h'
 
      common/ excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
      common/ cst8 /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
 

      do i = 1, isoct
         if (unnown.eq.sname(i)) then
             itis = i
             goto 99
         end if
      end do

 
      do i = 1, iphct
         if (unnown.eq.names(i)) then
            itis = 0
            icpd = i
            goto 99
         end if
      end do 
 
      itis = -1
99    end

      subroutine chsprp (lop,icx,jcx,jcx1,icps,rcps)
c----------------------------------------------------------------
c chsprp asks the user to choose a property for contouring:
c   lop  - flag indicating the property chosen
c   icx  - if lop = 6, the component chosen
c   icx  - if lop > 6, the identity of the solution chosen,
c          icx = -1 if a solution is not chosen.
c   jcx  - if lop = 7, the identity of the compound chosen,
c          if a solution is not chosen.
c   jcx  - if lop = 8, the number of components to define the
c          the phase composition.
c   icps - if lop = 8, the indices of the components. 
c   jflu - 0 include fluids for bulk props, else 1.

c 1                 Specific enthalpy (J/m3)',
c 2                 Density (kg/m3)',
c 3                'Specific Heat capacity (J/K/m3)',
c 4                'Expansivity (1/K, for volume)',
c 5                'Compressibility (1/bar, for volume)',
c 6                'Weight percent of a component',
c 7                'Mode (Vol %) of a compound or solution',
c 8                'Composition of a solution'
c 9                 Grueneisen thermal ratio',
c 10               'Adiabatic bulk modulus (bar)',
c 11               'Shear modulus (bar)'
c 12                Sound velocity (km/s)
c 13               'P-wave velocity (km/s)',
c 14                S-wave velocity (km/s)',
c 15                Vp/Vs
c 16               'Specific Entropy (J/K/m3)'
c 17               'Entropy (J/K/kg)'
c 18               'Enthalpy (J/kg)'
c 19               'Heat Capacity (J/K/kg)'
c 20               'Specific mass (kg/m3) of a phase'
c 21               'Poisson's Ratio'
c 22               'Molar Volume (J/bar)'
c----------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      parameter (kprop=22)

      character*5 cname

      real nopt
 
      common/ csta4 /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst320 /jflu/ opts /iopt(10),nopt(10)

      real rcps(k7)

      integer icps(k7)

      character propty(kprop)*60, y*1, units*15

      save propty

      data propty/'Specific Enthalpy (J/m3)',
     *            'Density (kg/m3)',
     *            'Specific heat capacity (J/K/m3)',
     *            'Expansivity (1/K, for volume)',
     *            'Compressibility (1/bar, for volume)',
     *            'Weight (%) of a component',
     *            'Mode (Vol, Mol, or Wt proportion) of a phase',
     *            'Composition (Mol or Wt) of a solution',
     *            'Grueneisen thermal ratio',
     *            'Adiabatic bulk modulus (bar)',
     *            'Adiabatic shear modulus (bar)',
     *            'Sound velocity (km/s)',
     *            'P-wave velocity (Vp, km/s)',
     *            'S-wave velocity (Vs, km/s)',
     *            'Vp/Vs',
     *            'Specific entropy (J/K/m3)',
     *            'Entropy (J/K/kg)',
     *            'Enthalpy (J/kg)',
     *            'Heat Capacity (J/K/kg)',
     *            'Specific mass of a phase (kg/m3-solid)',
     *            'Poisson ratio','Molar Volume (J/bar)'/
c-------------------------------------------
      jflu = 0
c                                choose property
5000  write (*,1050)

      do i = 1, kprop
         write (*,1060) i,propty(i)
      end do 

      read (*,*,iostat=ier) lop
      call rerror (ier,*5000)

      if (lop.eq.7.or.lop.eq.20) then 
c                                modes:
c                                get the phase name
          call rnam1 (icx,jcx)
c                                ask if fluid should be included:
          if (ivol.ne.0) then 
             write (*,1120) 
             read (*,'(a)') y
             if (y.eq.'y'.or.y.eq.'Y') jflu = 1 
          end if 

      else if (lop.ne.6.and.lop.ne.8) then 
c                                if lop .ne. 6 or 8 ask if
c                                bulk property or a phase property
         write (*,1110) 
         read (*,'(a)') y
         if (y.ne.'y'.and.y.ne.'Y') then 
            icx = -1 
            jcx = -1 
c                                it's a bulk property, ask if fluid
c                                should be included:
            if (ivol.ne.0) then 
               write (*,1120) 
               read (*,'(a)') y
               if (y.eq.'y'.or.y.eq.'Y') jflu = 1 
            end if 

         else 
c                                get the phase name
            call rnam1 (icx,jcx)
            if (icx.lt.1.and.lop.eq.8) write (*,*) 
     *         'hey cowboy, that warnt no solution, try again'
         end if
 
      else if (lop.eq.6) then
c                                get the component to be contoured
5010     write (*,1000)
         write (*,1010) (i,cname(i),i = 1, icomp)
         read (*,*,iostat=ier) icx
         call rerror (ier,*5010)   
c                                ask if fluids included
         if (ivol.ne.0) then 
            write (*,1120) 
            read (*,'(a)') y
            if (y.eq.'y'.or.y.eq.'Y') jflu = 1 
         end if 

      else if (lop.eq.8) then
c                                get the solution identity
5005     call rnam1 (icx,jcx)
         if (icx.lt.1) then 
            write (*,*) 'hey cowboy, that warnt no solution, try again'
            goto 5005
         end if 
c                                choose units for composition
         if (iopt(2).eq.0) then
            units = 'mole proportion'
         else 
            units = 'weight fraction'
         end if 
c                                get the composition to be contoured
         write (*,1100) units

5050     write (*,1030) 'numerator'
         read (*,*,iostat=ier) jcx
         call rerror (ier,*5050) 
c                                define the numerator
5020     write (*,1040) 'numerator'
         write (*,1010) (i,cname(i),i = 1, icomp)
         read (*,*,iostat=ier) (icps(i),rcps(i), i = 1, jcx)
         call rerror (ier,*5020) 
c                                define the denominator
5030     write (*,1030) 'denominator'
         write (*,1140)
         read (*,*,iostat=ier) jcx1
         call rerror (ier,*5030) 
         jcx1 = jcx + jcx1

         if (jcx1.gt.jcx) then 
5040        write (*,1040) 'denominator'
            write (*,1010) (i,cname(i),i = 1, icomp)
            read (*,*,iostat=ier) (icps(i),rcps(i), i = jcx+1, jcx1)
            call rerror (ier,*5040)
c                                show the user the composition: 
            write (*,1080)           
            write (*,1130) (rcps(i),cname(icps(i)), i = 1, jcx)
            write (*,*) '   divided by '
            write (*,1130) (rcps(i),cname(icps(i)), i = jcx+1, jcx1)
         else 
            write (*,1070) (rcps(i),cname(icps(i)), i = 1, jcx)
         end if 
 
         write (*,1090)
         read (*,'(a)') y
         if (y.ne.'y') goto 5020
      end if 

1000  format (/,'Enter a component:')
1010  format (2x,i2,' - ',a5)
1020  format (/,'Component index and weighting factor for the',
     *        /,'compositions numerator?')
1030  format (/,'How many components in the ',a,' of the',
     *          ' composition?')
1040  format (/,'Component indices and weighting factors for the', 
     *        /,'compositions ',a,'?')
1050  format (/,'Select a property:')
1060  format (3x,i2,' - ',a60)
1070  format (/,'The compositional variable is: ',f4.1,1x,a5)
1080  format (/,'The compositional variable is: ',/)
1090  format (/,'Happy (y/n?)')
1100  format (/,'Compositions are defined as a ratio of the form:',/,
     *        4x,' Sum {w(i)*n(i), i = 1, c1} / Sum {w(i)*n(i), i',
     *        ' = c2, c3}',/,15x,
     *        ' n(j) = ',a,' of component j',/,15x,
     *        ' w(j) = weighting factor of component j (usually 1)',/)
1110  format (/,'Calculate individual phase properties (y/n)?')
1120  format (/,'Include fluid in computation of aggregate ', 
     *          '(or modal) properties (y/n)?')
1130  format (' Sum ',20(f4.1,1x,a5,1x))
1140  format ('Enter zero to plot the numerator.')

99    end

      subroutine polprp (prop,x,y)

      implicit none

      include 'perplex_parameters.h'

      real rcps, prop, x, y, vmin, vmax, xn, yn, cprop, dx, dy, wt(3),
     *     nopt

      integer icps, icx, jcx, jcx1, lop, iam, itri(4), jtri(4), iop0,
     *        iopt, ijpt, loopy, loopx, igrd, j, iv ,jinc, n4, ifont,
     *        icopt, jwidth

      common/ cst84  /rcps(k7),icps(k7),icx,jcx,jcx1,lop
      common/ opts   /iopt(10),nopt(10)/ vs /vmin(l3),vmax(l3),iv
      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
      common/ basic  /n4,ifont,icopt,jwidth,iop0


c                             amiin gets iam, the pointer to the assemblage
c                             in the "b" file as a function of x-y coordinate
      call amiin (x,y,iam)  

      if (iam.eq.0) then 

         prop = -1e0
         write (*,1000) x, y

      else if (icopt.eq.1.or.iopt(4).eq.1) then

         call getprp (x,y,lop,iam,prop,icx,jcx,jcx1,icps,rcps)

      else 

        call triang (x,y,itri,jtri,ijpt,wt)

         if (ijpt.lt.3) then 
            call getprp (x,y,lop,iam,prop,icx,jcx,jcx1,icps,rcps)
         else 

            cprop = 0d0 

            do j = 1, 3

               xn = vmin(1) + (itri(j)-1)*dx
               yn = vmin(2) + (jtri(j)-1)*dy

               iam = igrd(itri(j),jtri(j))

               call getprp (xn,yn,lop,iam,prop,icx,jcx,jcx1,icps,rcps)

               cprop = cprop + wt(j)*prop

            end do 

            prop = cprop

         end if 

      end if 

1000  format ('Missing data at: ',2(g12.6,1x),' assigned value -1')
      end 

      subroutine getprp (x,y,lop,jd,prop,icx,jcx,jcx1,icps,rcps)
c----------------------------------------------------------------
c getprp gets properties:

c   jd   - is the pointer to the assemblage
c   jflu - if 1, bulk properties include fluid phase; else 0

c   lop  - flag indicating the property chosen
c   icx  - if lop = 6, the component chosen
c   icx  - if lop > 6, the identity of the solution chosen,
c          icx = -1 if a solution is not chosen.
c   jcx  - if lop = 7, the identity of the compound chosen,
c          if a solution is not chosen.
c   jcx  - if lop = 8, the number of components to define the
c          numerator of the phase composition.
c   jcx  - if lop > 8 the identity of the compound if icx < 0,
c          if jcx and icx < 0, then bulk properties are to be 
c          computed.
c   jcx1 - if lop = 8, the number of components + jcx that define the
c          denominator of the phase composition.
c   icps - if lop = 8, the indices of the components. 
c   
c requestable properties (indicated by lop)

c 1                 Specific enthalpy (J/m3)',
c 2                 Density (kg/m3)',
c 3                 Specific Heat capacity (J/K/m3)',
c 4                 Expansivity (1/K, for volume)',
c 5                 Compressibility (1/bar, for volume)
c 6                 Weight percent of a component
c 7                 Mode (Vol %) of a compound or solution',
c 8                 Composition of a solution'
c 9                 Grueneisen thermal ratio',
c 10                Adiabatic bulk modulus (bar)',
c 11                Sound velocity (km/s)
c 12                Shear modulus (bar)',
c 13                P-wave velocity (km/s)',
c 14                S-wave velocity (km/s)',
c 15                Vp/Vs
c 16                Specific Entropy (J/K/m3)'
c 17                Entropy (J/K/kg)'
c 18                Enthalpy (J/kg)'
c 19                Heat Capacity (J/K/kg)'
c 20                Specific mass of phase (kg/m3)
c 21                Poisson's Ratio 
c 22                Molar Volume (J/bar) 

c system properties from seismo:

c 1 vsys       - sys molar volume 
c 2 esys       - sys molar enthalpy 
c 3 grun       - sys gruenesien ratio
c 4 bulkm      - sys adiabatic bulk modulus
c 5 mu         - sys shear modulus
c 6 vel0       - sys sound velocity 
c 7 velp       - sys p-wave velocity
c 8 vels       - sys s-wave velocity
c 9 vp/vs      
c 10 rsys      - sys density
c 11 csys      - sys specific heat capacity
c 12 cp
c 13 alpha
c 14 beta 
c 15 entropy
c----------------------------------------------------------------

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      real rcps(k7)

      integer icps(k7)

      common/ cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)/ cst320 /jflu
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ phase /ikp(k1)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi 

      if (lop.eq.8) then 
c                                  a solution composition
         call scomp (jd,prop,icx,jcx,jcx1,icps,rcps)

      else if (lop.eq.6) then 
c                                  wt % of component 
         if (iflu(jd).eq.0.or.(iflu(jd).eq.1.and.jflu.eq.1)) then 
c                                  include fluid
            prop = fbulk(icx,jd)*atwt(icx)/btot(jd)*1e2
         else 
c                                  exclude fluid
            prop = fbulk1(icx,jd)*atwt(icx)/btot1(jd)*1e2
         end if 
      
      else 
c                                  get p-t for thermo props:
         call xytopt (x,y,p,t,dp,dt,jd)
c                                  calculate phase and bulk props
         call seismo (p,t,dp,dt,jd)
c                                  according to props:
         if (lop.eq.7.or.lop.eq.20) then 
c                                  modes are a special case, vmodes
c                                  returns the renormalized mode if that has 
c                                  been requested. 
            call vmodes (prop,p,t,lop,icx,jcx,jd)

         else if (icx.lt.0.and.jcx.lt.0) then 
c                                  a system property is  requested:
            if (iflu(jd).eq.0.or.(iflu(jd).eq.1.and.jflu.eq.1)) then 
c                                  if jflu = 0 the property is to include 
c                                  fluid (if present), i.e, use psys/ptot array:
               if (lop.eq.1) then 
c 1                                  Specific enthalpy (J/m3)
c                                    psys(2)  is J/mole
c                                    psys(1)  is J/bar/mole (volume)
                  prop = psys(2)/psys(1)*1d5
               else if (lop.eq.2) then 
c 2                                  Density (kg/m3)
                  prop = psys(10)
               else if (lop.eq.3) then 
c 3                                  Specific Heat capacity (J/K/m3)
                 prop = psys(12)/psys(1)*1d5
               else if (lop.eq.4) then
c 4                                  Expansivity (1/K, for volume)
                  prop =  psys(13)
               else if (lop.eq.5) then 
c 5                                  Compressibility (1/bar, for volume)
                  prop =  psys(14)
               else if (lop.ge.9.and.lop.le.15) then 
c                                    gruneisen T, K, mu, Vphi, vp, vs, vp/vs
                  prop = psys(lop-6) 
               else if (lop.eq.16) then 
c                                    specific s (j/k/m3)
                  prop = psys(15)/psys(1)*1d5
               else if (lop.eq.17) then 
c                                    S (J/K/kg)
                  prop = psys(15)/psys(1)*1d5/psys(10)
               else if (lop.eq.18) then 
c                                    H (J/kg)
                  prop = psys(2)/psys(1)*1d5/psys(10)
               else if (lop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = psys(12)/psys(1)*1d5/psys(10)
               else if (lop.eq.21) then 
c                                    Poisson's ratio
                  if (psys(8).eq.0d0) then 
                     prop = 0.5
                  else 
                     r = (psys(7)/psys(8))**2
                     prop = 0.5d0*(r-2d0)/(r-1d0)
                  end if 
               else if (lop.eq.22) then
c                                    molar volume
                  prop = psys(1)
               end if 
            else 
c                               fluid absent system properties:
               if (lop.eq.1) then 
c 1                                  Specific enthalpy (J/m3)
                  prop = psys1(2)/psys1(1)*1d5
               else if (lop.eq.2) then 
c 2                                  Density (kg/m3)
                  prop = psys1(10)
               else if (lop.eq.3) then 
c 3                                  Specific Heat capacity (J/K/m3)
                  prop = psys1(12)/psys1(1)*1d5
               else if (lop.eq.4) then
c 4                                  Expansivity (1/K, for volume)
                  prop =  psys1(13)
               else if (lop.eq.5) then 
c 5                                  Compressibility (1/bar, for volume)
                  prop =  psys1(14)
               else if (lop.ge.9.and.lop.le.15) then 
c                                    gruneisen T, K, mu, Vphi, vp, vs, vp/vs
                  prop = psys1(lop-6) 
               else if (lop.eq.16) then
c                                    specific s (j/k/m3)
                  prop = psys1(15)/psys1(1)*1d5
               else if (lop.eq.17) then
c                                    S (J/K/kg)
                  prop = psys1(15)/psys1(1)*1d5/psys1(10)
               else if (lop.eq.18) then 
c                                    H (J/kg)
                  prop = psys1(2)/psys1(1)*1d5/psys1(10)
               else if (lop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = psys1(12)/psys1(1)*1d5/psys1(10)
               else if (lop.eq.21) then 
c                                    Poisson's ratio
                  if (psys1(8).eq.0d0) then 
                     prop = 0.5
                  else 
                     r = (psys1(7)/psys1(8))**2
                     prop = 0.5d0*(r-2d0)/(r-1d0)
                  end if 
               else if (lop.eq.22) then
c                                    molar volume
                  prop = psys1(1)
               end if 
            end if 
         else 
c                               we want a phase property:
             call vmodes (prop,p,t,lop,icx,jcx,jd)

         end if 

      end if                
 
99    end 

      subroutine scomp (jd,comp,icx,jcx,jcx1,icps,rcps)
c-------------------------------------------------------------------
c function scomp returns composition of a solution phase in 
c assemblage jd. if the phase is a solution icx is its index (>0),
c otherwise jcx is its index. the index is determined by rnam1.
c ------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      real rcps(k7), cps(k5), nopt

      integer icps(k7)
 
      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / phase /ikp(k1)/ opts /iopt(10),nopt(10)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst20 /comps(k1,k5),atwt(k5),icomp

      comp = 0e0 
      totden = 0e0 
      tmol = 0e0

      do j = 1, jbulk
         cps(j) = 0d0
      end do 

      do i = 1, jbulk

         if (ikp(idbk(i,jd)).eq.icx) then 
c                                          first get the solution 
c                                          molar composition
            do j = 1, jbulk
               cps(j) = cps(j) + props(1,i,jd)*comps(idbk(i,jd),j)
            end do 

            tmol = tmol + props(1,i,jd)
         end if 
      end do 
c                                           if tmol = 0 not found
      if (tmol.eq.0d0) goto 99

      if (iopt(2).eq.0) then 
c                                           normalize composition to 
c                                           molar stoichiometry
         do i = 1, jbulk
            cps(i) = cps(i)/tmol
         end do 

      else 
c                                           normalize to weight fractions
         tmass = 0d0 

         do i = 1, jbulk 
            cps(i) = cps(i) * atwt(i)
            tmass = tmass + cps(i)
         end do 

         do i = 1, jbulk 
            cps(i) = cps(i)/tmass*1d2
         end do 
      end if 
c                                           now compute the composition:
c                                           numerator:
      do j = 1, jcx 
         comp = comp + rcps(j)*cps(icps(j))
      end do
c                                           denominator:
      do j = jcx+1, jcx1 
         totden = totden + rcps(j)*cps(icps(j))
      end do     
c                                           numerator/denominator:        
      if (totden.ne.0e0) comp = comp / totden

99    end

      function wtp (jcomp,jd)
c-------------------------------------------------------------------
c function wtp returns weight fraction of component jcomp in 
c assemblage jd.
c ------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'
 
      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst20 /comps(k1,k5),atwt(k5),icomp

      if (iflu(jd).eq.0) then 
        
            wtp = fbulk(jcomp,jd)*atwt(jcomp)/btot(jd)*1e2                           
  
      else 
c                                   if fluid is present use 
c                                   solid-only totals:
            wtp = fbulk1(jcomp,jd)*atwt(jcomp)/btot(jd)*1e2  

      end if 

      end

      subroutine vmodes (prop,p,t,iprop,icx,jcx,jd) 
c-------------------------------------------------------------------
c function vmode returns a property of a phase in 
c assemblage jd. if the phase is a solution icx is its index (>0),
c otherwise jcx is its index. the index is determined by rnam1.

c the property is identified by the index iprop:

c 1                 enthalpy (J/m3)
c 2                 density (kg/m3)
c 3                 Heat capacity (J/K/m3)
c 4                 Expansivity (1/K, for volume)
c 5                 Compressibility (1/bar, for volume)
c 7                 Mode (Vol %) of a compound or solution
c 9                 Grueneisen thermal ratio
c 10                Adiabatic bulk modulus (bar)

c 11                Sound velocity (km/s)
c 12                Shear modulus (bar)
c 13                P-wave velocity (km/s)
c 14                S-wave velocity (km/s)
c 15                Vp/Vs
c 16                Specific Entropy (J/K/m3)'
c 17                Entropy (J/K/kg)'
c 18                Enthalpy (J/kg)'
c 19                Heat Capacity (J/K/kg)'
c------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      real nopt
 
      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ phase /ikp(k1)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi
     *      / cst320 /jflu/ cst322 /cwt(k5),swt(k5),twt(k5)
     *      / opts /iopt(10),nopt(10)

      prop = 0d0

      if (icx.gt.0) then 
c                                           we are looking for a solution
c                                           prop saved in sphi:
         do j = 1, nphi
            if (ikp(idphi(j)).eq.icx) then 
               if (iprop.eq.1) then
c                                           specific enthalpy 
                  prop = sphi(2,j)/sphi(1,j)*1e5
               else if (iprop.eq.2) then 
c                                           density (kg/m3)
                  prop = sphi(10,j)
               else if (iprop.eq.3) then 
c                                           specific cp 
                  prop = sphi(12,j)/sphi(1,j)*1e5
               else if (iprop.eq.4) then 
c                                           expansivity
                  prop = sphi(13,j)
               else if (iprop.eq.5) then 
c                                           compressibility
                  prop = sphi(14,j)
               else if (iprop.eq.7) then                           
c                                           mode (%)
                  if (jflu.eq.1.or.iflu(jd).eq.0) then
c                                           total mode:
                     if (iopt(3).eq.0) then 
c                                           volume fraction
                        prop = sphi(11,j)*1e2
                     else   
c                                           weight fraction
c                                           corrected from ptot(1->2)
c                                           March 29, 05.
                        prop = swt(j)/ptot(2,jd)*1e2
                     end if 
                  else 
c                                           solid only mode:
                     if (iopt(3).eq.0) then 
c                                           volume fraction
                        prop = sphi(11,j)*1e2*psys(1)/psys1(1)
                     else 
c                                           wt fraction
c                                           corrected from ptot(1->2)
c                                           March 29, 05.
                        prop = swt(j)/ptot1(2,jd)*1e2
                     end if 
                  end if 
               else if (iprop.ge.9.and.iprop.le.15) then 
c                                    gruneisen T, K, mu, Vphi, vp, vs, vp/vs
                  prop = sphi(iprop-6,j) 
               else if (iprop.eq.16) then
c                                    specific s (j/k/m3)
                  prop = sphi(15,j)/sphi(1,j)*1d5
               else if (iprop.eq.17) then 
c                                    S (J/K/kg)
                  prop = sphi(15,j)/sphi(1,j)*1d5/sphi(10,j)
               else if (iprop.eq.18) then 
c                                    H (J/kg)
                  prop = sphi(2,j)/sphi(1,j)*1d5/sphi(10,j)
               else if (iprop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = sphi(12,j)/sphi(1,j)*1d5/sphi(10,j)
               else if (iprop.eq.20) then                           
c                                           specific weight of a
c                                           phase is the mass per
c                                           m3 of solid+melt

c                                           the number of moles of
c                                           system/m3 is 1e5/psys(1)
c                                           twt is g/mol phase                                        
                  if (iflu(jd).eq.0) then
c                                           total mode:
                     prop = swt(j)*1e2/psys(1)
                  else 
c                                           solid only mode:
                     prop = swt(j)*1e2/psys1(1)
                  end if 
               else if (iprop.eq.21) then 
c                                    Poisson's ratio
                  if (sphi(8,j).eq.0d0) then 
                     prop = 0.5
                  else 
                     r = (sphi(7,j)/sphi(8,j))**2
                     prop = 0.5d0*(r-2d0)/(r-1d0)
                  end if 
               else if (iprop.eq.22) then
c                                    molar volume
                  prop = sphi(1,j)
               end if 
               goto 99 
            end if 
         end do 

      else
c                                           we are looking for a cpd in iprop
         do j = 1, jbulk
            id = idbk(j,jd)
            if (id.eq.jcx) then 
               if (iprop.eq.1) then
c                                           specific enthalpy
                  prop = pphi(2,j)/pphi(1,j)*1e5
               else if (iprop.eq.2) then 
c                                           density
                  prop = pphi(10,j)
               else if (iprop.eq.3) then 
c                                           specific cp 
                  prop = pphi(12,j)/pphi(1,j)*1e5
               else if (iprop.eq.4) then 
c                                           expansivity
                  prop = pphi(13,j)
               else if (iprop.eq.5) then 
c                                           compressibility
                  prop = pphi(14,j)
               else if (iprop.eq.7) then                           
c                                           mode (%)
                  if (jflu.eq.0.or.iflu(jd).eq.0) then
c                                           total mode:
                     prop = pphi(11,j)*1e2
                  else 
c                                           solid only mode:
                     prop = pphi(11,j)*1e2*psys(1)/psys1(1)
                  end if 
               else if (iprop.ge.9.and.iprop.le.15) then 
c                                    gruneisen T, K, mu, Vphi, vp, vs, vp/vs
                  prop = pphi(iprop-6,j)  
               else if (iprop.eq.16) then
c                                    specific s (j/k/m3)
                  prop = pphi(15,j)/pphi(1,j)*1d5
               else if (iprop.eq.17) then 
c                                    S (J/K/kg)
                  prop = pphi(15,j)/pphi(1,j)*1d5/pphi(10,j)
               else if (iprop.eq.18) then 
c                                    H (J/kg)
                  prop = pphi(2,j)/pphi(1,j)*1d5/pphi(10,j)
               else if (iprop.eq.19) then
c                                    Cp (J/K/kg)
                  prop = pphi(12,j)/pphi(1,j)*1d5/pphi(10,j)
               else if (iprop.eq.20) then 
c                                           specific weight of a
c                                           phase is the mass per
c                                           m3 of solid+melt

c                                           the number of moles of
c                                           system/m3 is 1e5/psys(1)
c                                           twt is g/mol phase                                        
                  if (iflu(jd).eq.0) then
c                                           total mode:
                     prop = cwt(j)*1e2/psys(1)
                  else 
c                                           solid only mode:
                     prop = cwt(j)*1e2/psys1(1)
                  end if 
               else if (iprop.eq.21) then 
c                                    Poisson's ratio
                  if (pphi(8,j).eq.0d0) then 
                     prop = 0.5
                  else 
                     r = (pphi(7,j)/pphi(8,j))**2
                     prop = 0.5d0*(r-2d0)/(r-1d0)
                  end if 
               else if (iprop.eq.22) then
c                                    molar volume
                  prop = pphi(1,j)
               end if 
               goto 99 
            end if 
         end do 

      end if     

99    end

      subroutine inblnk (text,char)
c------------------------------------------------------------------- 
c inblnk - scan text to last '/' or '\' and insert char after.
 
c     text - character string 
c-------------------------------------------------------------------
 
      character text*(*), bitsy(400)*1, char*1 
 
      read (text,1000) bitsy
c                                 scan for blanks:
      ict = 0
      nchar = len(text)

      do i = nchar,1,-1
         if (bitsy(i).eq.'/') goto 10
         bitsy(i+1) = bitsy(i)
      end do 

      i = 0

10    bitsy(i+1) = char

      write (text,1000) (bitsy(i), i = 1, nchar)
 
1000  format (400a1)

      end

      subroutine seismo (p,t,dp,dt,jd)  
c-------------------------------------------------------------------
c input:

c   p, t, dp, dt - conditions set by prior call to  xytopt 

c output:

c 1 - vphi(k5)   - cpd volume 
c 2 - ephi(k5)   - cpd enthalpy 
c 3 - grunp(k5)  - cpd gruenesien ratio
c 4 - bulkmp(k5) - cpd adiabatic bulk modulus
c 5 - mup(k5)    - cpd shear modulus
c 6 - vel0p(k5)  - cpd sound velocity 
c 7 - velsp(k5)  - cpd s-wave velocity
c 8 - velpp(k5)  - cpd p-wave velocity
c 9 - vp/vs
c10 - rhop(k5)   - cpd density
c11 - vfract(k5) - cpd volume fraction
c12 - cp
c13 - alpha
c14 - beta 
c15 - entropy

c 1 vsys       - sys molar volume (j/bar/mol)
c 2 esys       - sys molar enthalpy (j/mol)
c 3 grun       - sys gruenesien ratio
c 4 bulkm      - sys adiabatic bulk modulus
c 5 mu         - sys shear modulus
c 6 vel0       - sys sound velocity 
c 7 velp       - sys p-wave velocity
c 8 vels       - sys s-wave velocity
c 9 vp/vs      
c 10 rsys      - sys density
c 11 csys      - sys specific heat capacity
c 12 cp
c 13 alpha
c 14 beta 
c 15 entropy

c wt  - array of pseudocompound masses per mole of system
c twt - array of phase masses per model of system
c-------------------------------------------------------------------
      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h' 

      real pgeo(i7), pgeo1(i7), alpha, chi, chi1, nopt

      integer ikrank, iopt, np, ncpd, idsol, krank(k5), lkrank(k5),
     *        kkrank(k5), jflug(k5)

      common/ cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst317 /pphi(i7,k5),psys(i7),psys1(i7),sphi(i7,k5),
     *                idphi(k5),nphi
     *      / cst319 /iemod(k2),kmod/ phase /ikp(k1)
     *      / cst322 /cwt(k5),swt(k5),twt(k5)/ opts /iopt(10),nopt(10)
     *      / cst20  /comps(k1,k5),atwt(k5),icomp
     *      / cst324 /scomps(k5,k5),pcomp(k5,k5)
     *      / cst326 /np(k2),ncpd(k2),npcpd(k2),idsol(k5,k2)
c                                      etoll, ctoll lower tolerance on 
c                                      legitimate expansivities and 
c                                      compressibilities.
c                                      for expansivity upper is ideal
c                                      gas at 300 K (1/T). lower is 
c                                      arbitrary.
c                                      for compressibility lower is 
c                                      1/(1000 GPa), upper is ideal 
c                                      gas at 1 bar (1/p).
      save itic, etolu, etoll, ctolu, ctoll
      data itic, etolu, etoll, ctolu, ctoll/0, 3e-3, 1e-6, 1e0, 1e-7/
c                                      weighting scheme for seismic velocity
c                                      chi = 1 -> voigt
c                                            0 -> reuss
      chi = nopt(6)
      chi1 = 1d0 - chi
c                                      initialize
      do j = 1, i7
         psys(j) = 0d0
         pgeo(j) = 0d0
         psys1(j) = 0d0
         pgeo1(j) = 0d0
         do i = 1, jbulk
            sphi(j,i) = 0d0
         end do 
      end do
c                                       initial true phase counter and props
      nphi = 0
      jtic = 0
      ktic = 0 
      ikrank = 0 
      jkrank = 0 
      iwarn = 0 
      do i = 1, jbulk
         krank(i) = 0
         kkrank(i) = 0
         lkrank(i) = 0
      end do 

      cumwt = 0d0
c                                    first loop gets basic props
c                                    and simple means:
      do i = 1, npcpd(jd)

         idphi(i) = 0
c                                    cpd id:
         id = idbk(i,jd)
c                                    bad assemblage, bad exit
         if (id.eq.0) goto 99
c                                    save phase compositions in units 
c                                    of choice (from iopt(2))
         if (iopt(2).eq.0) then 
c                                    we want molar phase compositions
            do k = 1, icomp
               pcomp(i,k) = comps(id,k)
            end do 

         else 
c                                    weight compositions:
            do k = 1, icomp
               pcomp(i,k) = comps(id,k)*atwt(k)/props(2,i,jd)*1e2
            end do    
         end if 
c                                    wt for molar wieghted system props
         wt        = props(1,i,jd)
         if (wt.lt.0d0) wt = 0d0
c                                    mass of phase per mole of system
         cwt(i)    = wt * props(2,i,jd)
         cumwt = cumwt + cwt(i)
c                                    cpd molar volume
         pphi(1,i) = props(4,i,jd) 
c                                    + dv/dp at Tr
     *               +(props(7,i,jd) + props(10,i,jd)*dp/2d0)*dp
c                                    including high order 
c                                    terms seems to be asking for 
c                                    trouble.
     *               +(props(6,i,jd) + props( 9,i,jd)*dp
     *                               + props( 8,i,jd)*dt/2d0)*dt
c                                    cpd heat capacity
         pphi(12,i) = props(5,i,jd) 
c                                    cpd expansivity
         pphi(13,i) = (props(6,i,jd) + props( 9,i,jd)*dp
     *               + props( 8,i,jd)*dt)/pphi(1,i)
c                                    cpd compressibility
         pphi(14,i) = -(props(7,i,jd) + props( 9,i,jd)*dt
     *                                + props(10,i,jd)*dp)/pphi(1,i)
c                                    check for errors and use simple 
c                                    values on error
c                                    here assume 1/K < 1/(1000 GPa)
c                                    (compressibilities < 1d-7 bar) are
c                                    invalid
         if (pphi(1,i).le.0d0.or.pphi(13,i).lt.etoll.or.
     *                           pphi(13,i).gt.etolu.or.
     *                           pphi(14,i).lt.ctoll.or.
     *                           pphi(14,i).gt.ctolu) then 

            iwarn = 1
            itic = itic + 1
            pphi(1,i) = props(4,i,jd)
            pphi(13,i) = props(6,i,jd)/pphi(1,i)
            pphi(14,i) = -props(7,i,jd)/pphi(1,i)
            if (pphi(1,i).le.0d0) then
               pphi(1,i) = 1d0
               ikrank = 1
               kkrank(i) = 1 
            end if 
            if (pphi(13,i).lt.etoll.or.pphi(13,i).gt.etolu) then
               pphi(13,i) = 0d0
               ikrank = 1
               kkrank(i) = 1 
            end if 
            if (pphi(14,i).lt.ctoll.or.pphi(14,i).gt.ctolu) then
               pphi(14,i) = 0d0
               ikrank = 1
               kkrank(i) = 1 
            end if 
         end if 
c                                    cpd entropy ds = cp/t*dt - V*alpha*dp
         pphi(15,i) = props(11,i,jd)  
c                                    + cp dlnt
     *              + pphi(12,i) * log( t/(t-dt) )
     *              - pphi(1,i)*pphi(13,i) * dp
c                                    cpd molar enthalpy, approx
         pphi(2,i) = (props(3,i,jd) 
c                                    + cp dt
     *              + dt * props(5,i,jd) 
c                                    + v dp 
     *              + dp * pphi(1,i))
c                                    system molar volume
         psys(1) = psys(1) + pphi(1,i)*wt 
c                                    molar enthalpy
         psys(2) = psys(2) + pphi(2,i)*wt 
c                                    molar heat capacity
         psys(12) = psys(12) + pphi(12,i)*wt 
c                                    expansivity
         psys(13) = psys(13) + pphi(13,i)*cwt(i) 
c                                    compressibility
         psys(14) = psys(14) + pphi(14,i)*cwt(i) 
c                                    molar entropy
         psys(15) = psys(15) + pphi(15,i)*wt 

         if (iflu(jd).eq.1) then 
c                                    assemblage includes fluid
            if (iflug(i,jd).eq.0) then
c                                    get total without fluid
               psys1(1) = psys1(1) + pphi(1,i)*wt 
c                                    molar enthalpy
               psys1(2) = psys1(2) + pphi(2,i)*wt 
c                                    molar heat capacity
               psys1(12) = psys1(12) + pphi(12,i)*wt 
c                                    molar expansivity
               psys1(13) = psys1(13) + pphi(13,i)*cwt(i) 
c                                    molar compressibility
               psys1(14) = psys1(14) + pphi(14,i)*cwt(i) 
c                                    molar entropy
               psys1(15) = psys1(15) + pphi(15,i)*wt 
            end if 
         end if 
      end do 
c                                    correct for proportional wt 
c                                    on intensive properties (alpha, beta). 
      psys(13) = psys(13)/cumwt
      psys(14) = psys(14)/cumwt 
      if (psys1(1).ne.0d0) then 
         psys1(13) = psys1(13)/psys1(1)
         psys1(14) = psys1(14)/psys1(1)   
      end if        
c                                    coming out of this loop
c                                    we have the following errors:
c                                    ikrank = 1 v, beta, or alpha infeasible.
c                                    in this case we do not calculate 
c                                    velocities, we could compute density.


c                                    total volume now can be used
c                                    for second loop
      do i = 1, npcpd(jd)
c                                    cpd id:
         id = idbk(i,jd)
c                                    volume fraction
         pphi(11,i) = props(1,i,jd)*pphi(1,i)/psys(1)      
c                                    ------------------------------------
c                                    create derivative properties:
c                                    for each compound:     
         if (pphi(12,i).gt.0d0.and.kkrank(i).eq.0) then 
c                                    Thermal Grueneisen Ratio (dimensionless)
            pphi(3,i) = pphi(1,i)/
     *                      (pphi(12,i)*pphi(14,i)/pphi(13,i) - 
     *                      t*pphi(13,i)*pphi(1,i))
c                                     check for weird volume stuff
            if (pphi(3,i).lt.0e0) then 
               pphi(3,i) = 0d0 
               ikrank = 1
               kkrank(i) = 1 
            end if 
         else 
            pphi(3,i) = 0d0           
         end if 
c                                    Shear Modulus (bar)
         pphi(5,i) = props(12,i,jd) + dp*props(13,i,jd) 
     *                              + dt*props(14,i,jd)
c                                    this is the old version, for taras
c        pphi(5,i) = props(12,i,jd) + (p-1)*props(13,i,jd) 
c     *                              + (t-300d0)*props(14,i,jd)
c                                    stixtrudes EoS may give bad shear mod
         if (pphi(5,i).le.0d0.and.iflug(i,jd).eq.0) then 
            jkrank = 1
            lkrank(i) = 1
            pphi(5,i) = 0d0
         end if 

         if (kkrank(i).eq.0) then 
c                                    no weird volume problems:
c                                    Adiabatic Bulk Modulus (bar)
            pphi(4,i) = (1d0 + t*pphi(13,i)
     *                          *pphi(3,i))/pphi(14,i)
c                                    density (kg/m3)
            pphi(10,i) = props(2,i,jd)/pphi(1,i)*1e2
c                                    sound velocity (km/s)
            pphi(6,i) = dsqrt(pphi(4,i)*1d5/pphi(10,i))/1d3
c                                    p-wave velocity
            pphi(7,i) = dsqrt((pphi(4,i)+4d0*pphi(5,i)/3d0)*1d5
     *                  /pphi(10,i))/1d3
c                                    s-wave velocity
            pphi(8,i) = dsqrt(pphi(5,i)*1d5/pphi(10,i))/1d3

            pphi(9,i) = pphi(8,i)/pphi(7,i)

         else 
c                                    some weird volume problems:
            pphi(3,i) = nopt(7)
c                                    Adiabatic Bulk Modulus (bar)
            pphi(4,i) = nopt(7)
c                                    density (kg/m3)
            pphi(10,i) = props(2,i,jd)/pphi(1,i)*1e2
c                                    sound velocity (km/s)
            pphi(6,i) = nopt(7)
c                                    p-wave velocity
            pphi(7,i) = nopt(7)
c                                    s-wave velocity 
            pphi(8,i) = dsqrt(pphi(5,i)*1d5/pphi(10,i))/1d3

            pphi(9,i) = nopt(7)

         end if 
c                                    number of non-fluid compounds with shear moduli
         if (pphi(5,i).ne.0d0.and.iflug(i,jd).eq.0) jtic = jtic + 1
c                                    if fluid is present, then the number of fluid
c                                    compunds
         if (iflu(jd).eq.1.and.iflug(i,jd).eq.1) ktic = ktic + 1

      end do
c                                    coming out of this loop
c                                    we have the following errors:
c                                    jkrank = 1 missing/infeasible shear mod.

c                                    now convert the pseudocompound 
c                                    properties to phase properties
      nphi = np(jd)+ncpd(jd)
      icpd = 0

      do i = 1, nphi

         if (i.le.np(jd).and.idsol(i,jd).eq.1.or.i.gt.np(jd)) then
c                                    the phase is represented by 
c                                    a single pseudocompound:
            icpd       = icpd + 1
            krank(i) = kkrank(icpd)
            jflug(i) = iflug(icpd,jd)
            sphi(1,i)  = pphi(1,icpd)
            sphi(2,i)  = pphi(2,icpd)
            sphi(5,i)  = pphi(5,icpd)
            do j = 10, 15
               sphi(j,i) = pphi(j,icpd)
            end do 
            swt(i)     = cwt(icpd)
c                                   this is only for the composition computed 
c                                   outside the if-construct.
            twt(i)     = props(1,icpd,jd)
            id         = idbk(icpd,jd)
            idphi(i)   = id
            do k = 1, icomp
               scomps(i,k) = comps(id,k)*twt(i)
            end do  

         else 
c                                    we have a phase that consists of
c                                    more than one compound:
c                                    initialization
            twt(i)    = 0d0
            vol       = 0d0
            enth      = 0d0
            rho       = 0d0
            cp        = 0d0
            alpha     = 0d0
            beta      = 0d0
            shearm    = 0d0
            vmode     = 0d0
            entr      = 0d0 
            swt(i)    = 0d0
            fwt       = 0d0 

            do k = 1, jbulk
               scomps(i,k) = 0d0
            end do 
c                                   sum properties
            do j = 1, idsol(i,jd)
               icpd      = icpd + 1
               wt        = props(1,icpd,jd)
               fwt       = fwt + wt*props(2,icpd,jd)
               swt(i)    = swt(i) + cwt(icpd)
               twt(i)    = twt(i) + wt    
               vol       = vol + wt * pphi(1,icpd)
               enth      = enth + wt * pphi(2,icpd)
               rho       = rho + wt * pphi(10,icpd)
               cp        = cp  + wt * pphi(12,icpd)
               alpha     = alpha + wt * pphi(13,icpd) 
               beta      = beta + wt * pphi(14,icpd)
               shearm    = shearm + wt *pphi(5,icpd)
               entr      = entr + wt * pphi(15,icpd)
               vmode     = vmode + pphi(11,icpd)
               id        = idbk(icpd,jd)
               idphi(i)  = id
               do k = 1, icomp
                  scomps(i,k) = scomps(i,k) + wt * comps(id,k)
               end do 

               krank(i) = kkrank(icpd)
               jflug(i) = iflug(icpd,jd)

            end do

            if (twt(i).gt.0d0) then 
c                                    compute phase props:
               sphi(1,i)  = vol/twt(i)
               sphi(2,i)  = enth/twt(i)
               sphi(5,i)  = shearm/twt(i)
               sphi(10,i) = rho/twt(i)
               sphi(11,i) = vol/psys(1) 
               sphi(12,i) = cp/twt(i)
               sphi(13,i) = alpha/twt(i)
               sphi(14,i) = beta/twt(i)
               sphi(15,i) = entr/twt(i)
            end if 
         end if 
c                                    now we have the basic phase properties
c                                    next compute derived properties
         if (iopt(2).eq.0.and.twt(i).gt.0d0) then 
c                                    we want molar phase compositions
            do k = 1, icomp
               scomps(i,k) = scomps(i,k)/twt(i)
            end do 
         else if (iopt(2).ne.0) then 
c                                    weight compositions:
            rwt = 0d0
            do k = 1, icomp
               scomps(i,k) = scomps(i,k)*atwt(k)
               rwt = rwt + scomps(i,k)
            end do        
            do k = 1, icomp
               scomps(i,k) = scomps(i,k)/rwt*1d2
            end do         
         end if 

         if (krank(i).eq.0.and.twt(i).gt.0d0) then 
c                                    Thermal Grueneisen Ratio (dimensionless)
            sphi(3,i) = sphi(1,i)/(sphi(14,i)*sphi(12,i)/sphi(13,i) 
     *                  - t*sphi(13,i)*sphi(1,i))
            if (sphi(3,i).le.0) then 
               sphi(3,i) = 0 
               ikrank = 1
               krank(i) = 1
            end if 
         end if 

         if (krank(i).eq.0.and.twt(i).ne.0d0) then 
c                                    no weird volume problems:
c                                    Adiabatic Bulk Modulus (bar)
            sphi(4,i) = (1d0 + t*sphi(13,i)*sphi(3,i))/sphi(14,i)
c                                    sound velocity (km/s)
            sphi(6,i) = dsqrt(sphi(4,i)*1d5/sphi(10,i))/1d3
c                                    p-wave velocity
            sphi(7,i) = dsqrt((sphi(4,i)+4d0*sphi(5,i)/3d0)
     *                            *1d5/sphi(10,i))/1d3
c                                    s-wave velocity
            sphi(8,i) = dsqrt(sphi(5,i)*1d5/sphi(10,i))/1d3

            sphi(9,i) = sphi(8,i)/sphi(7,i)
c                                    compute system sums:
c                                    These depend on weighting scheme,
c                                    here we use Voigt-Reuss-Hill.
c                                    Aggregate Gruneisen Ratio
            psys(3) = psys(3) + sphi(11,i)*sphi(3,i)*chi
            pgeo(3) = pgeo(3) + sphi(11,i)/sphi(3,i)
c                                    Aggregate Bulk Modulus                                
            psys(4) = psys(4) + sphi(11,i)*sphi(4,i)*chi
            pgeo(4) = pgeo(4) + sphi(11,i)/sphi(4,i)
c                                    Aggregate Sound
            psys(6) = psys(6) + sphi(11,i)*sphi(6,i)*chi
            pgeo(6) = pgeo(6) + sphi(11,i)/sphi(6,i)
c                                    Aggregate Vp                                
            psys(7) = psys(7) + sphi(11,i)*sphi(7,i)*chi
            pgeo(7) = pgeo(7) + sphi(11,i)/sphi(7,i)
c                                    Arithmetic means for mu and Vs
            psys(5) = psys(5) + sphi(11,i)*sphi(5,i)*chi
            psys(8) = psys(8) + sphi(11,i)*sphi(8,i)*chi

            if (iemod(jd).eq.jbulk) then 
c                                    Aggregate Shear Modulus, only
c                                    if shear mod is available for all
c                                    cpds.
               pgeo(5) = pgeo(5) + sphi(11,i)/sphi(5,i)
c                                    Aggregate Vs                               
               pgeo(8) = pgeo(8) + sphi(11,i)/sphi(8,i)
            end if
c                                    compute totals without fluid:
            if (jflug(i).eq.0.and.twt(i).gt.0d0) then 
c                                    renormalized fraction:
               frac = sphi(11,i)*psys(1)/psys1(1)
c                                    Aggregate Gruneisen Ratio
               psys1(3) = psys1(3) + frac*sphi(3,i)*chi
               pgeo1(3) = pgeo1(3) + frac/sphi(3,i)
c                                     Aggregate Bulk Modulus                                
               psys1(4) = psys1(4) + frac*sphi(4,i)*chi
               pgeo1(4) = pgeo1(4) + frac/sphi(4,i)
c                                     Aggregate Sound vel                                
               psys1(6) = psys1(6) + frac*sphi(6,i)*chi
               pgeo1(6) = pgeo1(6) + frac/sphi(6,i)
c                                    Vp
               psys1(7) = psys1(7) + frac*sphi(7,i)*chi
               pgeo1(7) = pgeo1(7) + frac/sphi(7,i)
c                                    Arithmetic means for mu and Vs
               psys1(5) = psys1(5) + frac*sphi(5,i)*chi
               psys1(8) = psys1(8) + frac*sphi(8,i)*chi


               if (sphi(5,i).ne.0d0) then 
c                                    Aggregate Shear Modulus, only
c                                    if shear mod is available for all
c                                    cpds.
                  pgeo1(5) = pgeo1(5) + frac/sphi(5,i)
c                                    Vs
                  pgeo1(8) = pgeo1(8) + frac/sphi(8,i)
               end if
            end if 

         else if (twt(i).ne.0d0) then 

            ikrank = 1
c                                    volume problems:
            sphi(3,i) = nopt(7)
c                                    Adiabatic Bulk Modulus (bar)
            sphi(4,i) = nopt(7)
c                                    sound velocity (km/s)
            sphi(6,i) = nopt(7)
c                                    p-wave velocity
            sphi(7,i) = nopt(7)
c                                    s-wave velocity
            sphi(8,i) = nopt(7)

            sphi(9,i) = nopt(7)

         end if 
 
      end do 

      psys(3) = psys(3) + chi1/pgeo(3)
      psys(4) = psys(4) + chi1/pgeo(4)
c                                    density
      psys(10) = ptot(2,jd)/psys(1)*1e2
c                                    sound velocity
      psys(6) = dsqrt(psys(4)*1d5/psys(10))/1d3
c                                    p-wave velocity
      psys(7) = psys(7) + chi1/pgeo(7)

      if (iemod(jd).eq.jbulk.and.ikrank.eq.0) then 
c                                    there are shear moduli for every phase:
c                                    shear modulus
         psys(5) = psys(5) + chi1/pgeo(5)
c                                    s-wave velocity
         psys(8) = psys(8) + chi1/pgeo(8)
         psys(9) = psys(8)/psys(7)

      else if (ktic+jtic.eq.npcpd(jd).and.ikrank.eq.0) then 
c                                    shear moduli for everything but fluid
c                                    then don't add harmonic mean:
c                                    shear modulus
         psys(5) = psys(5)/chi
c                                    s-wave velocity
         psys(8) = psys(8)/chi 
         psys(9) = psys(8)/psys(7)
      else 
         psys(3) = nopt(7)
         psys(4) = nopt(7)
         psys(5) = nopt(7)
         psys(6) = nopt(7)
         psys(7) = nopt(7)
         psys(8) = nopt(7)
         psys(9) = nopt(7)
      end if 

      if (iflu(jd).eq.1) then 
c                                    assemblage contains fluid, compute
c                                    fluid absent properties:
c                                    molar volume
         psys1(3) = psys1(3) + chi1/pgeo1(3)
         psys1(4) = psys1(4) + chi1/pgeo1(4) 
c                                    sound velocity
         psys1(6) = psys1(6) + chi1/pgeo1(6)
         psys1(10) = ptot1(2,jd)/psys1(1)*1e2

         if (jtic.eq.npcpd(jd)-ktic.and.ikrank.eq.0) then 
c                                    shear modulus
            psys1(5) = psys1(5) + chi1/pgeo1(5)
c                                    p-wave velocity
            psys1(7) = psys1(7) + chi1/pgeo1(7)
c                                    s-wave velocity
            psys1(8) = psys1(8) + chi1/pgeo1(8)

            psys1(9) = psys1(7)/psys1(8)
         else 
            psys1(3) = nopt(7)
            psys1(4) = nopt(7)
            psys1(5) = nopt(7)
            psys1(6) = nopt(7)
            psys1(7) = nopt(7)
            psys1(8) = nopt(7)
            psys1(9) = nopt(7)
         end if 

         psys1(6) = dsqrt(psys1(4)*1d5/psys1(10))/1d3
         
      end if 

99    if (iwarn.eq.1.and.itic.lt.100) then 
         itic = itic + 1
         write (*,1000) t,p

         if (itic.eq.100) then 
            write (*,*) 'this warning will not be repeated for future'
            write (*,*) 'instances of this problem'
         end if 
      end if 


1000  format ('**WARNING** at T(K)=',g12.4,' P(bar)=',g12.4,' a phase',
     *       /,'has invalid physical properties, this may result in',/,
     *         'incorrect densities and seismic velocities. this error'
     *      ,/,'can usually be avoided by turning compression off ',/,
     *         'when you run VERTEX (set JTEST=3)',/)
      end 

      subroutine readop 
c----------------------------------------------------------------------
c readop - readop looks for the werami_option.dat file, if it finds
c the option file it scans the file for keywords and sets options
c accordingly.
c----------------------------------------------------------------------
      implicit none

      integer lun, ier, iopt, i

      real nopt

      character*3 key, val, value(10), nval*12, nval1*12

      save lun

      data lun/13/

      common / opts /iopt(10),nopt(10)

c                                   default option values:
      iopt(1) = 1
      value(1) = 'on '
      iopt(2) = 0 
      value(2) = 'mol'
      iopt(3) = 0 
      value(3) = 'vol'
c                                   interpolation keyword
      iopt(4) = 0
      value(4) = 'on '
      nopt(4) = 2d0
c                                   extrapolation keyword
      iopt(5) = 0
      value(5) = 'on'
c                                   vrh_weighting keyword
      nopt(6) = 0.5d0
c                                   bad_number keyword
      nopt(7) = 0d0
c                                   solvus_tolerance keyword
      nopt(8) = 0.1
c                                   zero_mode (<0 off)
      nopt(9) = 1d-6
c                                   look for file
      open (lun, file = 'perplex_option.dat', iostat = ier, 
     *      status = 'old')
c                                   no option file, set defaults
      if (ier.ne.0) goto 99
c                                   read cards to end of 
c                                   option file
      do while (ier.eq.0) 

         call readcd (lun,ier,key,val,nval,nval1)
c                                   ier ne 0 bad record or eof
         if (ier.ne.0) exit 
c                                   if here we should have a keyword and
c                                   value
         if (key.eq.'ave') then
c                                   average pseudocompounds key
            if (val.eq.'on') then
               iopt(1) = 1
            else if (val.eq.'off') then 
               iopt(1) = 0 
            else 
               iopt(1) = 2
            end if 
            value(1) = val
         else if (key.eq.'com') then 
c                                   phase composition key
            if (val.eq.'wt') then
               iopt(2) = 1
            else 
               iopt(2) = 0
            end if 
            value(2) = val
         else if (key.eq.'pro') then 
c                                   phase proportion key
            if (val.eq.'wt') then
               iopt(3) = 1
            else if (val.eq.'mol') then 
               iopt(3) = 2 
            else 
c                                   volume is default
               iopt(3) = 0
            end if 
            value(3) = val
         else if (key.eq.'int') then 
c                                   interpolation key
            if (val.eq.'on ') then
               iopt(4) = 0
            else 
               iopt(4) = 1
            end if 
            value(4) = val
            read (nval1,*) nopt(4)
         else if (key.eq.'ext') then 
c                                   extrapolation key
            if (val.eq.'on ') then
               iopt(5) = 0
            else 
               iopt(5) = 1
            end if 
            value(5) = val
         else if (key.eq.'vrh') then 
c                                   vrh weighting key
            read (nval,*) nopt(6)
         else if (key.eq.'bad') then 
c                                   bad number key
            read (nval,*) nopt(7)
         else if (key.eq.'sol') then 

            read (nval,*) nopt(8)

         else if (key.eq.'zer') then
c                                   zero_mode key
            read (nval,*) nopt(9)
         end if 
      end do 
                
99    close (lun)

      
      write (*,1000) 
      write (*,1010) (value(i),i=1,5),nopt(6),nopt(7),nopt(8),nopt(9)
      write (*,1020)

1000  format (/,'Output options are currently set as:',//,
     *          '    Keyword:      Value:     Permitted values ',
     *          '[default]:')
1010  format (4x,'average          ',a3,8x,'off [on ] both',/,
     *        4x,'compositions     ',a3,8x,'wt  [mol]',/,
     *        4x,'proportions      ',a3,8x,'wt  [vol]',/,
     *        4x,'interpolation    ',a3,8x,'off [on ]',/,
     *        4x,'extrapolation    ',a3,8x,'off [on ]',/,
     *        4x,'vrh_weighting    ',f3.1,8x,'0->1 [0.5]',/,
     *        4x,'bad_number       ',f7.0,4x,'[0.0]',/,
     *        4x,'solvus_tolerance ',f5.3,6x,'0->1 [0.1]   = 1 => off',/
     *        4x,'zero_mode        ',e7.1,4x,'0->1 [1e-6], < 0 => off',/
     *) 
1020  format ('To change these options edit or create',
     *        ' file perplex_option.dat',/,'See: ',
     *        'www.perplex.ethz.ch/perplex_options.html',/)

      end 



      subroutine readcd (lun,ier,key,val,nval,nval1)
c----------------------------------------------------------------------
c readcd - read 240 column card image from unit lun, strip out unwanted
c characters. ier = 1 -> eof.
c this routine seeks a card containg a keyword and as many as 
c two values (char variables nval, nval1), the
c first 3 letters of each is returned in char(1:6)
c----------------------------------------------------------------------    
      implicit none

      integer len, ier, iscan, i, iscnlt, ibeg, lun, iend, ist

      character chars(240)*1, card*240, key*3, val*3, nval*12,
     *          nval1*12
 
      ier = 0 

      ibeg = 0
  
      len = 0 

      card = ''

      do while (ibeg.ge.len) 

         read (lun,'(a)',end=90) card

         if (card.ne.'') then 
            read (card,'(240a)') chars
c                                    find end of data marker '|'
            len = iscan (1,240,chars,'|') - 1
c                                    find a non blank character
            ibeg = iscnlt (1,len,chars,' ')
         end if 

      end do 

      iend = ibeg + 2
c                                    ok, we've got the keyword
c                                    load 3 chars of keyword into
      write (key,'(3a1)') (chars(i), i = ibeg, iend)
c                                    find next blank 
      iend = iscan (iend,240,chars,' ') 
c                                    now locate the value:
      ibeg = iscnlt (iend,len,chars,' ')
c                                    now find trailing blank
      iend = iscan (ibeg,240,chars,' ') 
c                                    now save a longer version in case
c                                    the value is numeric
      if (iend-ibeg.gt.11) iend = ibeg + 11
c                                    should check for error
      write (val,'(3a1)') (chars(i), i = ibeg, ibeg + 2)
c                                    this is done in case the first
c                                    value is numeric
      write (nval,'(12a1)') (chars(i), i = ibeg, ibeg+11)
c                                    now look for a second value
      ist = ibeg + 3
c                                    find a non blank character
      ibeg = iscnlt (ist,len,chars,' ')
c                                    if no blank exit
      if (ibeg.gt.len) then 
         nval1 = '0'
      else 
         iend = iscan (ibeg,len,chars,' ')
         if (iend-ibeg.gt.11) iend = ibeg + 11 
         write (nval1,'(12a1)') (chars(i), i = ibeg, ibeg+11)
      end if 

      goto 99

90    ier = 1

99    end

      integer function iscan (ibeg,iend,chars,char)
c----------------------------------------------------------------------
      implicit none

      character chars(240)*1, char*1

      integer ibeg, iend

      do iscan = ibeg, iend

         if (chars(iscan).eq.char) exit

      end do 

      end 

      integer function iscnlt (ibeg,iend,chars,char)
c----------------------------------------------------------------------
      implicit none

      character chars(240)*1, char*1

      integer ibeg, iend


      do iscnlt = ibeg, iend

         if (chars(iscnlt).gt.char) exit

      end do 

      end 


	subroutine triang (x,y,itri,jtri,ijpt,wt)
c----------------------------------------------------------------------
c routine to extract interpolation points for the point x-y. the 
c algorithm seeks points over an interval of jinc(1), jnterp 
c should be read from perplex_option.dat but is currently set here to 1. 
c This whole process could be done 
c much more efficiently (and better) if the grid points were mapped 
c to a triangular mesh. 

c    returns:
c              ijpt       - number of good interpolation points
c              itri, jtri - nodal cordinates of the (3) interpolation 
c                           points
c              wt         - weights of interpolation points
c----------------------------------------------------------------------
      implicit none

      include 'perplex_parameters.h'

      real dx, dy, x, y, wt(3), px(3), py(3), vmin, vmax, div, 
     *     twt, dst(4), nopt

      integer igrd, loopx, loopy, jinc, jloc, iloc, j, i,
     *        k, l, idbk, ivar, iap, ibulk, iflu, iflug, jmax,
     *        itri(4), jtri(4), ijpt, iam, jam, kinc, jmin, 
     *        ijcor, imin, imax, iv, ktri(4), ltri(4), ibest, iopt

      logical rinsid, in, isok, jn

      integer pi(4,4)

      data pi/1, 2, 3, 4, 1, 2, 4, 3, 1, 3, 4, 2, 2, 3, 4, 1/

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
     *      / vs     /vmin(l3),vmax(l3),iv/ opts /iopt(10),nopt(10)
     *      / cst74  /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
c                                     identify the assemblage and
c                                     nodal coordinate     
      call amiin1 (x,y,iloc,jloc)

      ijpt = 0

      iam = iap(igrd(iloc,jloc))
c                                     make a spiral-like search outward
c                                     from the node to find interpolation
c                                     points
      kinc = 0       
c                                     the multiplier on jinc (the increment
c                                     for the lowest level grid) controls
c                                     the search area. 
      do while (kinc.le.ifix(nopt(4))*jinc)

         jmin = jloc - kinc
         jmax = jloc + kinc 

         do j = jmin, jmax
c                                     skip out of bounds points           
            if (j.lt.1.or.j.gt.loopy) cycle

            imin = iloc - kinc
            imax = iloc + kinc

            do 10 i = imin, imax
c                                     skip out of bounds points           
               if (i.lt.1.or.i.gt.loopx) cycle
c                                     skip interior points (this is sloppy)
               if (j.ne.jmin.and.j.ne.jmax.and.
     *             i.ne.imin.and.i.ne.imax) cycle 
c                                     is the point the same assemblage?
               if (iap(igrd(i,j)).ne.iam) cycle
c                                     pointer to reference node
               jam = igrd(i,j)
c                                     if so, is the point real?
               if (ijcor(jam,1).ne.i.or.ijcor(jam,2).ne.j) cycle
c                                     if here the point is valid, now
c                                     check if it's geometrically feasible
               if (ijpt.lt.2) then 
c                                     always take the two points
                  ijpt = ijpt + 1
                  itri(ijpt) = i
                  jtri(ijpt) = j

               else if (ijpt.eq.2) then 

                  itri(3) = i
                  jtri(3) = j      
c                                     check if on line of previous
c                                     points
                  if (isok(itri,jtri)) then 
                     ijpt = 3
                     in = rinsid(itri,x,jtri,y,dst(1))
                  end if 

               else if (ijpt.eq.3) then 
c                                     four permutations are possible
c                                     check all 
                  itri(4) = i
                  jtri(4) = j 
                  ibest = 1
     
                  do k = 2, 4
                     do l = 1, 3
                        ktri(l) = itri(pi(l,k))
                        ltri(l) = jtri(pi(l,k))
                     end do 


                     if (isok(ktri,ltri)) then

                        jn = rinsid(ktri,x,ltri,y,dst(k))

                        if (jn.and..not.(in)) then
c                                    no in prior bounding triangle, so
c                                    k is now the best guess  
                           ibest = k 
                           in = jn                    
                        else if (jn.and.in.or..not.(jn).and..not.(in))
     *                                                             then 
c                                    both are bounding, compare weights
c                                    (total distance to vertices).
                           if (dst(ibest).gt.dst(k)) then
                              ibest = k 
                           end if                              
                        end if 
                     end if 
                  end do    

                  if (ibest.ne.1) then 
c                                    load the best choice
                     do k = 1, 3
                        itri(k) = itri(pi(k,ibest))
                        jtri(k) = jtri(pi(k,ibest))
                     end do 
                  end if 

               end if 
10          continue
         end do 

         kinc = kinc + 1

      end do 
  
      if (ijpt.eq.3) then 

         do j = 1, 3
            px(j) = vmin(1) + (itri(j)-1)*dx
            py(j) = vmin(2) + (jtri(j)-1)*dy
         end do
c                                        compute iterpolation coefficients
         div = px(2)*py(3)-px(1)*py(3)-px(2)*py(1)+
     *         px(3)*py(1)-px(3)*py(2)+px(1)*py(2)
c                                        z[1] coef
         wt(1) = (y*(px(3)-px(2))+px(2)*py(3)-
     *            px(3)*py(2)+x*(py(2)-py(3)))/div
c                                        z[2] coef
         wt(2) = (px(3)*py(1)-px(1)*py(3)+
     *            y*(px(1)-px(3))-x*(py(1)-py(3)))/div
         if (wt(2).gt.0) twt = twt + wt(2)
c                                        z[3] coef
         wt(3) = (x*(py(1)-py(2))+px(1)*py(2)-px(2)*py(1)
     *           +y*(px(2)-px(1)))/div
         if (wt(3).gt.0) twt = twt + wt(3)
c                                        if the triangle is non-bounding
c                                        and extrapolation is off reset 
c                                        counter.
         if (.not.(in).and.iopt(5).eq.1) then 
            ijpt = 1
         end if 

      end if 

      end 

      logical function isok (itri,jtri)
c----------------------------------------------------------------------
c check if vertices itri-jtri define a triangle

      implicit none 

      integer itri(4), jtri(4)
      real m, b, di

      if (itri(1).eq.itri(2).and.itri(1).eq.itri(3).or.
     *    jtri(1).eq.jtri(2).and.jtri(1).eq.jtri(3)) then 

         isok = .false.

      else 
         di = itri(1) - itri(2)
         m = (-jtri(2)+jtri(1))/di
         b = -(jtri(1)*itri(2)-itri(1)*jtri(2))/di + 0.001
         if (jtri(3).eq.ifix(m*itri(3)+b)) then
            isok = .false.
         else
            isok = .true.
         end if 
      end if 

      end 

      logical function rinsid (itri,xp,jtri,yp,dst)
c----------------------------------------------------------------------
c function to determine if triangle i1-j1 ... i3-j3 bounds point xp - yp
c     returns true if internal or on an edge
c     returns false if outside or on a vertex.
c algorithm after jimscott@blackpawn.com
c                                              JADC 1/2005
c----------------------------------------------------------------------

      implicit none

      include 'perplex_parameters.h'

      logical rsmsid

      real dx, dy, vmax, vmin, xp, yp, x(3), y(3), dst, dist

      integer igrd, loopx, loopy, itri(4), jtri(4), iv, j, jinc

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
     *      / vs     /vmin(l3),vmax(l3),iv

c                                convert nodal coordinates to real
c                                cordinates
      dst = 0e0

      do j = 1, 3
         x(j) = vmin(1) + (itri(j)-1)*dx
         y(j) = vmin(2) + (jtri(j)-1)*dy
         dst = dst + dist(x,y,itri(j),jtri(j))
      end do 
c                                1->2 join
      if (rsmsid(x(2)-x(1),y(2)-y(1),x(3)-x(1),
     *           y(3)-y(1),xp-x(1),yp-y(1)).and.
c                                1->3 join
     *    rsmsid(x(3)-x(1),y(3)-y(1),x(2)-x(1),
     *           y(2)-y(1),xp-x(1),yp-y(1)).and.
c                                2->3 join
     *    rsmsid(x(3)-x(2),y(3)-y(2),x(1)-x(2),
     *           y(1)-y(2),xp-x(2),yp-y(2))) then

          rinsid = .true.

      else 

          rinsid = .false.

      end if 

      end 

      logical function rsmsid (x1,y1,x2,y2,x3,y3)
c----------------------------------------------------------------------
c function to determine if points (x1,y1) (x2,y2) are on the same side
c (or colinear with) the line (0,0)-(x3,y3) (if so true).

      real x1,y1,x2,y2,x3,y3
c                                   test the cross product, if 0 a point
c                                   is on the line.
      if ((x1*y3 - y1*x3)*(x1*y2 - y1*x2).ge.0) then
         rsmsid = .true.
      else
         rsmsid = .false.
      end if 

      end 

	real function dist (x,y,i,j)
c----------------------------------------------------------------------
c get distance from nodal point i,j to coordinate x-y      

      implicit none
 
      include 'perplex_parameters.h'

      real dx, dy, vmax, vmin, dely, delx, x, y

      integer igrd, loopx, loopy, jinc, i, j, iv

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
     *      / vs     /vmin(l3),vmax(l3),iv
 
c                                     find normalized distance 
      delx = (x - vmin(1))/dx - (i - 1)
      dely = (y - vmin(2))/dy - (j - 1)
      dist = sqrt (delx**2 + dely**2)

      end 

	subroutine amiin1 (x,y,i,j)
c----------------------------------------------------------------------
c amiin - identifies the grid point associated with coordinate x-y 
c         and the sector of the x-y coordinate relative the nodal point        

      implicit none
 
      include 'perplex_parameters.h'

      real dx, dy, vmax, vmin, res, del, x, y

      integer igrd, loopx, loopy, jinc, i, j, iv

      common/ cst309 /dx,dy,igrd(l7,l7),loopx,loopy,jinc
     *      / vs     /vmin(l3),vmax(l3),iv
 
c                                     find node associated with condition
      del = x-vmin(1)
      i = del/dx 
      res = del - i*dx
      if (res.gt.0.5*dx) i = i + 1
      i = i + 1

      del = y-vmin(2)
      j = del/dy 
      res = del - j*dy
      if (res.gt.0.5*dy) j = j + 1
      j = j + 1

      end 