
      subroutine plinp (fname,tmin,tmax,pmin,pmax)

      use input_output
 
c psxypl - subroutine to output x-y plot.

      implicit real (a-g,o-z),integer (h-n)
 
      character*8 tname(4)*162,vname,names,sname*10,fname*100,cname*5
 
      include 'perplex_parameters.h'

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
 
      common/ cst8  /names(k1)/ csta7 /sname(h9)/ phase /ikp(k1)
     *      / excl1 /ixct(3),iphct,isoct,iex(50,3),jex(50,3),ict(3)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / basic /n4,ifont,icopt,jwidth,iop0
     *      / csta4 /cname(k5)/ cst20 /comps(k1,k5),atwt(k5),icomp
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep
     *      / cst319 /iemod(k2),kmod  

      write (*,1070) 
      read (*,1000) fname

      open (n4,err=90,file=fname,status='old')

      read (n4,*,err=91) icopt
      read (n4,*) iphct, isoct, icomp
      read (n4,*) jbulk, ivol, icp, jvol, kmod
      if (icomp.ne.0) then
         read (n4,1040) (cname(i), i = 1, icomp)
         read (n4,*) (atwt(i), i = 1, icomp)
      end if 
      if (iphct.ne.0) then
         read (n4,1010) (names(i),i = 1, iphct)
         read (n4,*) ((comps(i,j), j= 1, icomp), i = 1, iphct)
         read (n4,*) (ikp(i), i = 1, iphct)
      end if
      if (isoct.ne.0) read (n4,1030) (sname(i), i = 1, isoct) 
      read (n4,1000) tname
      read (n4,*) iv,(jv(i),i=1,iv),jpt
      read (n4,*) jcont,iind,idep,c0,c1,c2,c3,c4
      read (n4,*) (vmax(i),vmin(i),i=1,iv)
      read (n4,1000) (vname(i),i=1,iv)

c for katja:

      tmin = vmin(1)
      tmax = vmax(1)
      pmin = vmin(2)
      pmax = vmax(2)

      goto 99

90    write (*,1060) fname
      stop
91    write (*,1050) fname
      stop

1000  format (a)
1010  format (10a8)
1030  format (8a10)
1040  format (20a5)
1050  format (/,'file:',/,a,/,'is not formatted correctly.',/)
1060  format (/,'No such file as: ',a,/)
1070  format (/,'Enter plot file name: ')

99    end


c-------------------------------------------------------------------
c this is copied verbatim from plib.f and modified to set nopt(9)
c (zero mode) on.

      subroutine bplinp (fname,kpoly)

c subroutine to read bulk composition data file for pseudosections.

c props(np,k5,k2) for the k5'th compund of the k2'th assemblage,
c np is the physical property as follows:

c    2 - atwt (g)
c    3 - molar enthalpy (J)
c    4 - volume (J/bar)
c    5 - Cp (J/K)
c    6 - dV/dT (J/bar/K)
c    7 - dV/dP (J/bar/bar)
c    8 - dCp/dT
c    9 - dCp/dP
c   10 - d2V/dT2
c   11 - (dV/dT)/dP
c   12 - (dV/dP)/dT
c   13 - dV2/dP2
c   14 - shear modulus
c   15 - temperature derivative of the shear modulus
c   16 - pressure derivative of the shear modulus

c iflu(k2) = 1 if fluid present, otherwise = 0.

c additionally we have the following proportions and bulk properties:

c  ptot(1,k2)  - aggregate total moles
c  ptot(2,k2)  - aggregate total weight
c  ptot(4,k2)  - aggregate total volume
c  ptot1(1,k2) - aggregate-fluid total moles
c  ptot1(2,k2) - aggregate-fluid total weight
c  ptot1(4,k2) - aggregate-fluid total volume

c from these we can define 

c props(1,i,jd)/ptot(1,jd)                 - compound mol fraction 
c props(1,i,jd)*props(2,i,jd)/ptot(2,jd)   - compound wt fraction
c props(1,i,jd)*props(4,i,jd)/ptot(4,jd)   - compound volume fraction


      implicit real (a-g,o-z),integer (h-n)

      character*100 fname, n5name
 
      include 'perplex_parameters.h'

      integer kdsol(k5), inew, hp, kp, jp, lp, nscpd,  
     *        ldsol(k5), idnew(k2), iass(k3),iopt

      real nopt

      common/ basic /n4,ifont,icopt,jwidth,iop0
     *      / cst74 /idbk(k5,k2),ivar(k2),iap(k2),ibulk,iflu(k2),
     *               iflug(k5,k2),ijcor(k2,2)
     *      / cst76 /props(i8,k5,k2),vr(l2,k2),vtemp(2,k2)
     *      / cst81 /ptot(2,k2),btot(k2),gtot(k2),fbulk(k5,k2)
     *      / cst82 /ptot1(2,k2),btot1(k2),gtot1(k2),fbulk1(k5,k2)
     *      / cst77 /ivol,jvol(2),jpt(2),jv(l3),jbulk,icp,pmn,dpr
     *      / cst20 /comps(k1,k5),atwt(k5),icomp/ phase /ikp(k1)
     *      / vs    /vmin(l3),vmax(l3),iv/ cst315 /jcont   
     *      / cst319 /iemod(k2),kmod/ opts /iopt(10),nopt(10)
     *      / cst316 /c0,c1,c2,c3,c4,iind,idep
     *      / cst326 /np(k2),ncpd(k2),npcpd(k2),idsol(k5,k2)

      n5 = n4 + 1
      ibulk = 1
      inew = 0 
      iapmax = 0 
      nopt(9) = 1e-6
c                                    open assemblage information
c                                    file = 'b' + plot file name.
      n5name = fname 
      call inblnk (n5name,'b')
      open (n5,err=90,file=n5name,status='old')

10    read (n5,*,end=20) jd, ivar(ibulk), iap(ibulk), iflu(ibulk),
     *                   (idbk(i,ibulk), i = 1, jbulk),
     *                   ijcor(ibulk,1), ijcor(ibulk,2),
     *                   np(ibulk),ncpd(ibulk),
c                                    kdsol is the solution flag, 
c                                    it's not needed so read it 
c                                    into a simple array.
     *                   (kdsol(i), i = 1, np(ibulk)),
     *                   (idsol(i,ibulk),i = 1, np(ibulk))

	if (iind.eq.0) then 
         read (n5,*) (vr(i,ibulk), i = 1, iv - jcont)
	else 
         read (n5,*) (vr(i,ibulk), i = 1, iv - jcont - 1)
	end if 

      read (n5,*) ((props(j,i,ibulk), j = 1, 11), i = 1, jbulk)
      read (n5,*) (ptot(j,ibulk), j = 1, 2),btot(ibulk),gtot(ibulk),
     *            (fbulk(j,ibulk), j = 1, icomp)
      if (iflu(jd).eq.1) then 
         read (n5,*) (iflug(j,ibulk), j = 1, jbulk)
         read (n5,*) (ptot1(j,ibulk), j = 1, 2),
     *        btot1(ibulk),gtot1(ibulk),(fbulk1(j,ibulk), j = 1, icomp)
      end if 
c                              shear moduli are only read as a special case:
      if (kmod.ne.0) then 
         read (n5,*) iemod(ibulk)
         if (iemod(ibulk).ne.0) read (n5,*) 
     *     ((props(j,i,ibulk), j= 12, 14), i = 1, jbulk)
      else 
         iemod(ibulk) = 0
      end if 
c                              default pseusdocompound counter, reset by zero_mode opt.
      npcpd(ibulk) = jbulk
      ivar(ibulk) = jbulk + 2 - np(ibulk) - ncpd(ibulk)
c                              eliminate zero mode phases if 
c                              zero_mode option is off
      if (nopt(9).ge.0d0) then 
c                              find the highest assemblage number.
         if (iapmax.lt.iap(ibulk)) iapmax = iap(ibulk)
         ip = 0 
         kp = 0
         lp = 0  
c                              first count non-zero solutions
         do i = 1, np(ibulk)
            jp = 0 
            do j = 1, idsol(i,ibulk)
               lp = lp + 1
               if (props(1,lp,ibulk).gt.nopt(9)) then
c               if (props(1,lp,ibulk).gt.1d-4.or.
c     *             iflug(i,ibulk).ne.0) then
                  ip = ip + 1
                  jp = jp + 1
                  kdsol(ip) = lp
               end if 
            end do 
            if (jp.ne.0) then 
               kp = kp + 1
               ldsol(kp) = jp
            end if 
         end do

         nscpd = ip
c                              the non zero pseudocompounds are 
c                              in kdsol, the counter per solution is
c                              in ldsol and kp is the number of 
c                              non-zero solutions.

c                              now count compounds:
         jp = 0 
         do i = lp+1, lp+ncpd(ibulk)             
            if (props(1,i,ibulk).ne.0d0) then
               jp = jp + 1
               kdsol(nscpd+jp) = i
            end if
         end do
c                              ok, now reassign props
         jflug = 0
         do i = 1, nscpd + jp
            idbk(i,ibulk) = idbk(kdsol(i),ibulk)
            iflug(i,ibulk) = iflug(kdsol(i),ibulk) 
            if (iflug(i,ibulk).ne.0) jflug = 1
            do j = 1, 14
               props(j,i,ibulk) = props(j,kdsol(i),ibulk)
            end do 
         end do

         if (iflu(jd).ne.0.and.jflug.eq.0) iflu(jd) = 0 

         np(ibulk) = kp
         ncpd(ibulk) = jp
         npcpd(ibulk) = nscpd + jp
         ivar(ibulk) = jbulk + 2 - np(ibulk) - ncpd(ibulk)
c                              load solution cpd counters:
         do i = 1, kp
            idsol(i,ibulk) = ldsol(i)
         end do 
c                              save index for reclassification
         if (nscpd+jp.lt.jbulk) then 
            inew = inew + 1
            idnew(inew) = ibulk
         end if 
      end if 

      ibulk = ibulk + 1
      goto 10

20    close (n5)
c                               now reclassify new assemblages
      if (inew.ne.0) then 
         iapmin = iapmax + 1
         iapmax = iapmax + 1
         iap(idnew(1)) = iapmax 
         if (inew.eq.1) goto 30
c                               classify the assemblage by saving
c                               an index
         iass(iapmax) = idnew(1)


         do 70 i = 2, inew 
            id = idnew(i)
            do 50 j = iapmin, iapmax
               jd = iass(j)
               if (np(jd).eq.np(id).and.ncpd(jd).eq.ncpd(id)) then
c                               first match solutions 
                  do 40 k = 1, np(id)
                     do l = 1, np(id)
                        if (ikp(idbk(k,id)).eq.ikp(idbk(l,jd))) goto 40
                     end do
c                               failed to match a solution, next assemblage
                     goto 50  
40                continue 
c                               now match compounds
                  do 60 k = npcpd(id)-ncpd(id)+1, npcpd(id)
                     do l = npcpd(id)-ncpd(id)+1, npcpd(id)
                        if (idbk(k,id).eq.idbk(l,jd)) goto 60 
                     end do 
c                               failed to match a pseudocompound, next assemblage
                     goto 50 
60                continue 
c                               if here we matched assemblage j
                  iap(id) = j  
                  goto 70 
               end if 
50          continue  
c                               if here id's a new assemblage
            iapmax = iapmax + 1
            iass(iapmax) = idnew(i)
70       continue  

         write (*,*) iapmax-iapmin,' new assemblages'

      end if 

30    ibulk = ibulk - 1
c                                    open polygon file = 'p' + plot file name.

      kpoly = ibulk 

      goto 99 

90    write (*,1000) n5name,fname
      stop

1000  format (/,'The bulk information file:',/,a,/,'corresponding to'
     *         ,' plot file:',/,a,/,'does not exist.',//)

99    end   

      subroutine inblnk (text,char)
c------------------------------------------------------------------- 
c inblnk - scan text to last '/' or '\' and insert char after.
 
c     text - character string 
c-------------------------------------------------------------------
 
      character text*(*), bitsy(400)*1, char*1 
 
      read (text,1000) bitsy
c                                 scan for blanks:
      ict = 0
      nchar = len(text)

      do i = nchar,1,-1
         if (bitsy(i).eq.'/'.or.bitsy(i).eq.'\') goto 10
         bitsy(i+1) = bitsy(i)
      end do 

      i = 0

10    bitsy(i+1) = char

      write (text,1000) (bitsy(i), i = 1, nchar)
 
1000  format (400a1)
      end