      integer h5,h6,h8,h9,i9,j9,k0,k1,k2,k3,k4,k5,k9,k10,k12,k13,k15
      integer k7,l2,l3,l5,l6,l7,m0,m6,m7,m8,m9,msp,mst,nsp,mdim
      integer m1,m2,m3,m4,m10,m11,m12,m13,m14,m15
      integer kd1,kd2,i7,i8,k14,l8,l1

!                                 h5  - max number of saturated components
!                                 h6  - max number of saturated composants in any subcomposition
!                                 h8  - max number of excluded phases
!                                 h9  - max number of solutions
      parameter (h5=5,h6=500,h8=200,h9=30)
!                                 i7  - number of system props used in werami
!                                 i8  - number of properties saved for each phase and
!                                       for the bulk composite, less than i8 properties
!                                       may be read from the bulk property file. 
!                                 i9  - max number of solution in solution model file
      parameter (i7=16,i8=14,i9=200)
!                                 j9  - max number of divariant assemblages
      parameter (j9=160000)
!                                 k0  - max number of database components
!                                 k1  - max number of compounds
!                                 k2  - max number of invariant and univariant compound 
!                                       equilibria and max number of divariant compound
!                                       assemblages for constrained bulk composition
!                                       calculations
!                                 k3  - max number of distinct phase (as opposed to 
!                                       pseudocompound assemblages)
!                                 k4  - number of parameters in PerpleX EoS
!                                 k5  - max total number of active components
!                                 k9  - maximum number of true compounds with lambda transitions
!                                 k10 - max number of true compounds
!                                 k12 - max number of end-members in a solution model
!                                 k13 - pseudocompound parameter array dimension
!                                 k14 - number of parameters in the data base EoS
!                                 k15 - number of elastic moduli parameters in the emod array
      parameter (k0=25,k1=100000,k2=20000,k3=500,k4=22,k5=15)
      parameter (k9=25,k10=200,k12=14,k13=8*k1,k14=18,k15=3)
!             
      parameter (k7=k5+1)   
!                                 l1 - max number of internal solutions (models for which
!                                      parameters are saved in global arrays).
!                                 l2 - max number of independent potential variables
!                                 l3 - max number of variables for graphics (l2+2)
!                                 l5 - max number of coordinates along a univariant curve                
!                                 l6 - max number of iterations in lp optimization, in 
!                                      theory this may be up to ca 5*(k1+k5), generally
!                                      convergence occurs in less than 100 iterations.
!                                 l7 - max number of grid points along an axis for
!                                      constrained minimization on a 2-d grid. this
!                                      array is not essential.  
!                                 l8 - max number of levels for multilevel grids            
      parameter (l1=8,l2=5,l3=l2+2,l5=1000,l6=1000,l7=1024,l8=10)
!                                 m0 - max number of terms for a species site fraction?
!                                 m1 - max number of terms in excess function
!                                 m2 - max order of term in excess function
!                                 m3 - number of parameters for excess function coefficients
!                                 m4 - max number of endmembers in a solution model,
!                                      should include dependent endmembers? in any
!                                      case this is defined as a dependent parm below
!                                 m6 - max number of "lambda" transitions per true compound
!                                 m7 - number of "lambda" parameters per transition
!                                 m8 - maximum number of parameters to describe T dependent ordering.
!                                 m9 - maximum number of true compounds with T-dependent ordering.
!                                m10 - maximum number of sites in Sconf model
!                                m11 - maximum number of species - 1 in Sconf model
!                                m12 - maximum order of terms in Sconf model
!                                m13 - maximum number of terms in endmember fraction
!                                      function expressed as a function of dependent
!                                      endmember
!                                m14 - max order of term in endmember fraction
!                                      function expressed as a function of dependent
!                                      endmember
!                                m15 - maximum number of dependent endmembers for a 
!                                      reciprocal solution
      parameter (m0=6,m1=28,m2=8,m3=3,m6=3,m7=12,m8=9,m9=10,m10=5)
      parameter (m11=5,m12=4,m13=8,m14=2,m15=4)
!                                 msp - max number of species on a solution identisite
!                                 mst - max number of distinct identisites per solution
!                                 mdim - hard constraint on max number of dimensions
!                                        for a solution model composition space.
      parameter (msp=8,mst=2,mdim=7)
!                                 nsp - max number of species in fluid speciation routines 
      parameter (nsp=11)


! NOTE: increasing parameter K5 requires changes to the following
! format statements:
!                     1000 in routine bulkck
!                     1000 in routine bulktst
!                     1150 in routine input1
!                     4000 in main in program build


!                                  the following are dependent parameters
      parameter (kd1=k5+2,kd2=kd1*31,m4=msp**mst+1)

